
package{

	import flash.display.*;
	import flash.events.*;
	import flash.media.*;
	import flash.utils.ByteArray;

	[SWF(width="640",height="480")]
	[Frame(factoryClass="Preloader")]
	
	public class MonkeyGame extends Sprite{
	
		public var runner:Function;
		
		public function MonkeyGame(){
		
			game=this;

			addEventListener( Event.ADDED_TO_STAGE,onAddedToStage );
		}
		
		private function onAddedToStage( e:Event ):void{
		
			try{
				bbInit();
				bbMain();

				if( runner!=null ) runner();

			}catch( err:Object ){
			
				printError( err.toString() );
			}
		}
		
		private function mungPath( path:String ):String{
			var i:int=path.indexOf( "." ),ext:String="";
			if( i!=-1 ){
				ext=path.slice(i+1);
				path=path.slice(0,i);
			}
			
			var munged:String="_";
			var bits:Array=path.split( "/" );
			
			for( i=0;i<bits.length;++i ){
				munged+=bits[i].length+bits[i];
			}
			munged+=ext.length+ext;
			
			return munged;
		}
		
		public function loadString( path:String ):String{
			var t:Class=Assets[ mungPath( path ) ];
			if( t ){
				var buf:ByteArray=(new t) as ByteArray;
				if( buf ) return buf.toString();
			}
			return "";
		}

		public function loadBitmap( path:String ):Bitmap{
			var t:Class=Assets[ mungPath( path ) ];
			if( t ) return (new t) as Bitmap;
			return null;
		}
		
		public function loadSound( path:String ):Sound{
			var t:Class=Assets[ mungPath( path ) ];
			if( t ) return (new t) as Sound;
			return null;
		}
	}		
}

var game:MonkeyGame;

final class Config{
//${CONFIG_BEGIN}
internal static var CONFIG:String="release"
internal static var HOST:String="winnt"
internal static var IMAGE_FILES:String="*.png|*.jpg"
internal static var LANG:String="as"
internal static var MOJO_AUTO_SUSPEND_ENABLED:String="false"
internal static var MOJO_IMAGE_FILTERING_ENABLED:String="true"
internal static var MUSIC_FILES:String="*.mp3"
internal static var PARSER_FUNC_ATTRS:String="0"
internal static var SOUND_FILES:String="*.mp3"
internal static var TARGET:String="flash"
internal static var TEXT_FILES:String="*.txt|*.xml|*.json"
//${CONFIG_END}
}

final class Assets{
//${ASSETS_BEGIN}
[Embed(source="data/mojo_font.png")]
public static var _9mojo_font3png:Class;
[Embed(source="data/buttons.png")]
public static var _7buttons3png:Class;
[Embed(source="data/explode.png")]
public static var _7explode3png:Class;
[Embed(source="data/gameover.png")]
public static var _8gameover3png:Class;
[Embed(source="data/instructions.png")]
public static var _12instructions3png:Class;
[Embed(source="data/main.png")]
public static var _4main3png:Class;
[Embed(source="data/mainscreen.png")]
public static var _10mainscreen3png:Class;
[Embed(source="data/mask.png")]
public static var _4mask3png:Class;
[Embed(source="data/normal.png")]
public static var _6normal3png:Class;
[Embed(source="data/pegasus.png")]
public static var _7pegasus3png:Class;
[Embed(source="data/twiball.png")]
public static var _7twiball3png:Class;
[Embed(source="data/unicorn.png")]
public static var _7unicorn3png:Class;
//${ASSETS_END}
}

//${TRANSCODE_BEGIN}

// Actionscript Monkey runtime.
//
// Placed into the public domain 24/02/2011.
// No warranty implied; use at your own risk.

//***** ActionScript Runtime *****

import flash.display.*;
import flash.text.*;
import flash.external.ExternalInterface;

//Consts for radians<->degrees conversions
var D2R:Number=0.017453292519943295;
var R2D:Number=57.29577951308232;

//private
var _console:TextField;
var _errInfo:String="?<?>";
var _errStack:Array=[];

var dbg_index:int=0;

function _getConsole():TextField{
	if( _console ) return _console;
	_console=new TextField();
	_console.x=0;
	_console.y=0;
	_console.width=game.stage.stageWidth;
	_console.height=game.stage.stageHeight;
	_console.background=false;
	_console.backgroundColor=0xff000000;
	_console.textColor=0xffffff00;
	game.stage.addChild( _console );
	return _console;
}

function pushErr():void{
	_errStack.push( _errInfo );
}

function popErr():void{
	_errInfo=_errStack.pop();
}

function stackTrace():String{
	if( !_errInfo.length ) return "";
	var str:String=_errInfo+"\n";
	for( var i:int=_errStack.length-1;i>0;--i ){
		str+=_errStack[i]+"\n";
	}
	return str;
}

function print( str:String ):int{
	var console:TextField=_getConsole();
	if( !console ) return 0;
	console.appendText( str+"\n" );
	return 0;
}

function printError( err:Object ):void{
	var msg:String=err.toString();
	if( !msg.length ) return;
	print( "Monkey Runtime Error : "+msg );
	print( "" );
	print( stackTrace() );
}

function error( err:String ):int{
	throw err;
}

function debugLog( str:String ):int{
	print( str );
	return 0;
}

function debugStop():int{
	error( "STOP" );
	return 0;
}

function dbg_object( obj:Object ):Object{
	if( obj ) return obj;
	error( "Null object access" );
	return obj;
}

function dbg_array( arr:Array,index:int ):Array{
	if( index<0 || index>=arr.length ) error( "Array index out of range" );
	dbg_index=index;
	return arr;
}

function new_bool_array( len:int ):Array{
	var arr:Array=new Array( len )
	for( var i:int=0;i<len;++i ) arr[i]=false;
	return arr;
}

function new_number_array( len:int ):Array{
	var arr:Array=new Array( len )
	for( var i:int=0;i<len;++i ) arr[i]=0;
	return arr;
}

function new_string_array( len:int ):Array{
	var arr:Array=new Array( len );
	for( var i:int=0;i<len;++i ) arr[i]='';
	return arr;
}

function new_array_array( len:int ):Array{
	var arr:Array=new Array( len );
	for( var i:int=0;i<len;++i ) arr[i]=[];
	return arr;
}

function new_object_array( len:int ):Array{
	var arr:Array=new Array( len );
	for( var i:int=0;i<len;++i ) arr[i]=null;
	return arr;
}

function resize_bool_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=false;
	return arr;
}

function resize_number_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=0;
	return arr;
}

function resize_string_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]="";
	return arr;
}

function resize_array_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=[];
	return arr;
}

function resize_object_array( arr:Array,len:int ):Array{
	var i:int=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=null;
	return arr;
}

function string_compare( lhs:String,rhs:String ):int{
	var n:int=Math.min( lhs.length,rhs.length ),i:int,t:int;
	for( i=0;i<n;++i ){
		t=lhs.charCodeAt(i)-rhs.charCodeAt(i);
		if( t ) return t;
	}
	return lhs.length-rhs.length;
}

function string_replace( str:String,find:String,rep:String ):String{	//no unregex replace all?!?
	var i:int=0;
	for(;;){
		i=str.indexOf( find,i );
		if( i==-1 ) return str;
		str=str.substring( 0,i )+rep+str.substring( i+find.length );
		i+=rep.length;
	}
	return str;
}

function string_trim( str:String ):String{
	var i:int=0,i2:int=str.length;
	while( i<i2 && str.charCodeAt(i)<=32 ) i+=1;
	while( i2>i && str.charCodeAt(i2-1)<=32 ) i2-=1;
	return str.slice( i,i2 );
}

function string_starts_with( str:String,sub:String ):Boolean{
	return sub.length<=str.length && str.slice(0,sub.length)==sub;
}

function string_ends_with( str:String,sub:String ):Boolean{
	return sub.length<=str.length && str.slice(str.length-sub.length,str.length)==sub;
}

function string_from_chars( chars:Array ):String{
	var str:String="",i:int;
	for( i=0;i<chars.length;++i ){
		str+=String.fromCharCode( chars[i] );
	}
	return str;
}

class ThrowableObject{
	internal function toString():String{
		return "Uncaught Monkey Exception";
	}
}

// Flash mojo runtime.
//
// Copyright 2011 Mark Sibly, all rights reserved.
// No warranty implied; use at your own risk.

import flash.display.*;
import flash.events.*;
import flash.media.*;
import flash.geom.*;
import flash.utils.*;
import flash.net.*;

var app:gxtkApp;

class gxtkApp{

	internal var graphics:gxtkGraphics;
	internal var input:gxtkInput;
	internal var audio:gxtkAudio;

	internal var dead:int=0;
	internal var suspended:int=0;
	internal var loading:int=0;
	internal var maxloading:int=0;
	internal var updateRate:int=0;
	internal var nextUpdate:Number=0;
	internal var updatePeriod:Number=0;
	internal var startMillis:Number=0;
	
	function gxtkApp(){
		app=this;
		
		graphics=new gxtkGraphics;
		input=new gxtkInput;
		audio=new gxtkAudio;
		
		startMillis=(new Date).getTime();
		
		game.stage.addEventListener( Event.ACTIVATE,OnActivate );

		game.stage.addEventListener( Event.DEACTIVATE,OnDeactivate );
		
		game.stage.addEventListener( Event.ENTER_FRAME,OnEnterFrame );
		
		SetFrameRate( 0 );
		
		game.runner=function():void{
			InvokeOnCreate();
			InvokeOnRender();
		};
	}

	internal function IncLoading():void{
		++loading;
		if( loading>maxloading ) maxloading=loading;
		if( loading!=1 ) return;
		if( updateRate ) SetFrameRate( 0 );
	}

	internal function DecLoading():void{
		--loading;
		if( loading ) return;
		maxloading=0;
		if( updateRate ) SetFrameRate( updateRate );
	}
	
	internal function SetFrameRate( fps:int ):void{
		if( fps ){
			updatePeriod=1000.0/fps;
			nextUpdate=(new Date).getTime()+updatePeriod;
			game.stage.frameRate=fps;
		}else{
			updatePeriod=0;
			game.stage.frameRate=24;
		}
	}
	
	internal function OnActivate( e:Event ):void{
		if( Config.MOJO_AUTO_SUSPEND_ENABLED=="true" ){
			InvokeOnResume();
		}
	}
	
	internal function OnDeactivate( e:Event ):void{
		if( Config.MOJO_AUTO_SUSPEND_ENABLED=="true" ){
			InvokeOnSuspend();
		}
	}
	
	internal function OnEnterFrame( e:Event ):void{
		if( !updatePeriod ) return;
		
		var updates:int=0;

		for(;;){
			nextUpdate+=updatePeriod;
			InvokeOnUpdate();
			if( !updatePeriod ) break;
			
			if( nextUpdate>(new Date).getTime() ) break;
			
			if( ++updates==7 ){
				nextUpdate=(new Date).getTime();
				break;
			}
		}
		InvokeOnRender();
	}
	
	internal function Die( err:Object ):void{
		dead=1;
		audio.OnSuspend();
		printError( err );
	}
	
	internal function InvokeOnCreate():void{
		if( dead ) return;
		
		try{
			dead=1;
			OnCreate();
			dead=0;
		}catch( err:Object ){
			Die( err );
		}
	}

	internal function InvokeOnUpdate():void{
		if( dead || suspended || !updateRate || loading ) return;
		
		try{
			input.BeginUpdate();
			OnUpdate();
			input.EndUpdate();
		}catch( err:Object ){
			Die( err );
		}
	}

	internal function InvokeOnRender():void{
		if( dead || suspended ) return;
		
		try{
			graphics.BeginRender();
			if( loading ){
				OnLoading();
			}else{
				OnRender();
			}
			graphics.EndRender();
		}catch( err:Object ){
			Die( err );
		}
	}
	
	internal function InvokeOnSuspend():void{
		if( dead || suspended ) return;
		
		try{
			suspended=1;
			OnSuspend();
			audio.OnSuspend();
		}catch( err:Object ){
			Die( err );
		}
	}
	
	internal function InvokeOnResume():void{
		if( dead || !suspended ) return;
		
		try{
			audio.OnResume();
			OnResume();
			suspended=0;
		}catch( err:Object ){
			Die( err );
		}
	}
	
	//***** GXTK API *****
	
	public function GraphicsDevice():gxtkGraphics{
		return graphics;
	}

	public function InputDevice():gxtkInput{
		return input;
	}

	public function AudioDevice():gxtkAudio{
		return audio;
	}

	public function AppTitle():String{
		return graphics.bitmap.loaderInfo.url;
	}
	
	public function LoadState():String{
		var file:SharedObject=SharedObject.getLocal( "gxtkapp" );
		var state:String=file.data.state;
		file.close();
		if( state ) return state;
		return "";
	}
	
	public function SaveState( state:String ):int{
		var file:SharedObject=SharedObject.getLocal( "gxtkapp" );
		file.data.state=state;
		file.close();
		return 0;
	}
	
	public function LoadString( path:String ):String{
		return game.loadString( path );
	}

	public function SetUpdateRate( hertz:int ):int{
		updateRate=hertz;

		if( !loading ) SetFrameRate( updateRate );

		return 0;
	}
	
	public function MilliSecs():int{
		return (new Date).getTime()-startMillis;
	}

	public function Loading():int{
		return loading;
	}

	public function OnCreate():int{
		return 0;
	}

	public function OnUpdate():int{
		return 0;
	}
	
	public function OnSuspend():int{
		return 0;
	}
	
	public function OnResume():int{
		return 0;
	}
	
	public function OnRender():int{
		return 0;
	}
	
	public function OnLoading():int{
		return 0;
	}

}

class gxtkGraphics{
	internal var bitmap:Bitmap;
	
	internal var red:Number=255;
	internal var green:Number=255;
	internal var blue:Number=255;
	internal var alpha:Number=1;
	internal var colorARGB:uint=0xffffffff;
	internal var colorTform:ColorTransform=null;
	internal var alphaTform:ColorTransform=null;
	
	internal var matrix:Matrix;
	internal var rectBMData:BitmapData;
	internal var blend:String;
	internal var clipRect:Rectangle;
	
	internal var shape:Shape;
	internal var graphics:Graphics;
	internal var bitmapData:BitmapData;

	internal var pointMat:Matrix=new Matrix;
	internal var rectMat:Matrix=new Matrix;
	
	internal var image_filtering_enabled:Boolean;
	
	function gxtkGraphics(){
	
		var stage:Stage=game.stage;
	
		bitmap=new Bitmap();
		bitmap.bitmapData=new BitmapData( stage.stageWidth,stage.stageHeight,false,0xff0000ff );
		bitmap.width=stage.stageWidth;
		bitmap.height=stage.stageHeight;
		game.addChild( bitmap );

		stage.addEventListener( Event.RESIZE,OnResize );
	
		rectBMData=new BitmapData( 1,1,false,0xffffffff );
		
		image_filtering_enabled=(Config.MOJO_IMAGE_FILTERING_ENABLED=="true");
	}
	
	internal function OnResize( e:Event ):void{
		var stage:Stage=game.stage;
		var w:int=stage.stageWidth;
		var h:int=stage.stageHeight;
		if( w==bitmap.width && h==bitmap.height ) return;
		bitmap.bitmapData=new BitmapData( w,h,false,0xff0000ff );
		bitmap.width=w;
		bitmap.height=h;
	}

	internal function BeginRender():void{
		bitmapData=bitmap.bitmapData;
	}

	internal function UseBitmap():void{
		if( graphics==null ) return;
		bitmapData.draw( shape,matrix,alphaTform,blend,clipRect,false );
		graphics.clear();
		graphics=null;
	}

	internal function UseGraphics():void{
		if( graphics!=null ) return;
		if( shape==null ) shape=new Shape;
		graphics=shape.graphics;
	}

	internal function FlushGraphics():void{
		if( graphics==null ) return;
		bitmapData.draw( shape,matrix,alphaTform,blend,clipRect,false );
		graphics.clear();
	}
	
	internal function EndRender():void{
		UseBitmap();
		bitmapData=null;
	}
	
	internal function updateColor():void{
	
		colorARGB=(int(alpha*255)<<24)|(int(red)<<16)|(int(green)<<8)|int(blue);
		
		if( colorARGB==0xffffffff ){
			colorTform=null;
			alphaTform=null;
		}else{
			colorTform=new ColorTransform( red/255.0,green/255.0,blue/255.0,alpha );
			if( alpha==1 ){
				alphaTform=null;
			}else{
				alphaTform=new ColorTransform( 1,1,1,alpha );
			}
		}
	}

	//***** GXTK API *****

	public function Mode():int{
		return 1;
	}
	
	public function Width():int{
		return bitmap.width;
	}

	public function Height():int{
		return bitmap.height;
	}

	public function LoadSurface( path:String ):gxtkSurface{
		var bitmap:Bitmap=game.loadBitmap( path );
		if( bitmap ) return new gxtkSurface( bitmap );
		return null;
	}
	
	public function CreateSurface( width:int,height:int ):gxtkSurface{
		var bitmapData:BitmapData=new BitmapData( width,height );
		var bitmap:Bitmap=new Bitmap( bitmapData );
		return new gxtkSurface( bitmap );
	}
	
	public function SetAlpha( a:Number ):int{
		FlushGraphics();
		
		alpha=a;
		
		updateColor();
		
		return 0;
	}
	
	public function SetColor( r:Number,g:Number,b:Number ):int{
		FlushGraphics();
		
		red=r;
		green=g;
		blue=b;
		
		updateColor();
		
		return 0;
	}
	
	public function SetBlend( blend:int ):int{
		switch( blend ){
		case 1:
			this.blend=BlendMode.ADD;
			break;
		default:
			this.blend=null;
		}
		return 0;
	}
	
	public function SetScissor( x:int,y:int,w:int,h:int ):int{
		FlushGraphics();
		
		if( x!=0 || y!=0 || w!=bitmap.width || h!=bitmap.height ){
			clipRect=new Rectangle( x,y,w,h );
		}else{
			clipRect=null;
		}
		return 0;
	}

	public function SetMatrix( ix:Number,iy:Number,jx:Number,jy:Number,tx:Number,ty:Number ):int{
		FlushGraphics();
		
		if( ix!=1 || iy!=0 || jx!=0 || jy!=1 || tx!=0 || ty!=0 ){
			matrix=new Matrix( ix,iy,jx,jy,tx,ty );
		}else{
			matrix=null;
		}
		return 0;
	}

	public function Cls( r:Number,g:Number,b:Number ):int{
		UseBitmap();

		var clsColor:uint=0xff000000|(int(r)<<16)|(int(g)<<8)|int(b);
		var rect:Rectangle=clipRect;
		if( !rect ) rect=new Rectangle( 0,0,bitmap.width,bitmap.height );
		bitmapData.fillRect( rect,clsColor );
		return 0;
	}
	
	public function DrawPoint( x:Number,y:Number ):int{
		UseBitmap();
		
		if( matrix ){
			var px:Number=x;
			x=px * matrix.a + y * matrix.c + matrix.tx;
			y=px * matrix.b + y * matrix.d + matrix.ty;
		}
		if( clipRect || alphaTform || blend ){
			pointMat.tx=x;pointMat.ty=y;
			bitmapData.draw( rectBMData,pointMat,colorTform,blend,clipRect,false );
		}else{
			bitmapData.fillRect( new Rectangle( x,y,1,1 ),colorARGB );
		}
		return 0;
	}
	
	
	public function DrawRect( x:Number,y:Number,w:Number,h:Number ):int{
		UseBitmap();

		if( matrix ){
			var mat:Matrix=new Matrix( w,0,0,h,x,y );
			mat.concat( matrix );
			bitmapData.draw( rectBMData,mat,colorTform,blend,clipRect,false );
		}else if( clipRect || alphaTform || blend ){
			rectMat.a=w;rectMat.d=h;rectMat.tx=x;rectMat.ty=y;
			bitmapData.draw( rectBMData,rectMat,colorTform,blend,clipRect,false );
		}else{
			bitmapData.fillRect( new Rectangle( x,y,w,h ),colorARGB );
		}
		return 0;
	}

	public function DrawLine( x1:Number,y1:Number,x2:Number,y2:Number ):int{
		UseGraphics();
		
		if( matrix ){

			var x1_t:Number=x1 * matrix.a + y1 * matrix.c + matrix.tx;
			var y1_t:Number=x1 * matrix.b + y1 * matrix.d + matrix.ty;
			var x2_t:Number=x2 * matrix.a + y2 * matrix.c + matrix.tx;
			var y2_t:Number=x2 * matrix.b + y2 * matrix.d + matrix.ty;
			
			graphics.lineStyle( 1,colorARGB & 0xffffff );	//why the mask?
			graphics.moveTo( x1_t,y1_t );
			graphics.lineTo( x2_t,y2_t );
			graphics.lineStyle();
			
			var mat:Matrix=matrix;matrix=null;

			FlushGraphics();

			matrix=mat;
			
		}else{

			graphics.lineStyle( 1,colorARGB & 0xffffff );	//why the mask?
			graphics.moveTo( x1,y1 );
			graphics.lineTo( x2,y2 );
			graphics.lineStyle();
		
			if( alphaTform ) FlushGraphics();
		}

		return 0;
 	}

	public function DrawOval( x:Number,y:Number,w:Number,h:Number ):int{
		UseGraphics();

		graphics.beginFill( colorARGB & 0xffffff );			//why the mask?
		graphics.drawEllipse( x,y,w,h );
		graphics.endFill();
		
		if( alphaTform ) FlushGraphics();

		return 0;
	}
	
	public function DrawPoly( verts:Array ):int{
		if( verts.length<6 ) return 0;
		
		UseGraphics();
		
		graphics.beginFill( colorARGB & 0xffffff );			//why the mask?
		
		graphics.moveTo( verts[0],verts[1] );
		for( var i:int=0;i<verts.length;i+=2 ){
			graphics.lineTo( verts[i],verts[i+1] );
		}
		graphics.endFill();
		
		if( alphaTform ) FlushGraphics();

		return 0;
	}

	public function DrawSurface( surface:gxtkSurface,x:Number,y:Number ):int{
		UseBitmap();

		if( matrix ){
			if( x!=0 || y!=0 ){
				//have to translate matrix! TODO!
				return -1;
			}
			bitmapData.draw( surface.bitmap.bitmapData,matrix,colorTform,blend,clipRect,image_filtering_enabled );
		}else if( clipRect || colorTform || blend ){
			var mat:Matrix=new Matrix( 1,0,0,1,x,y );
			bitmapData.draw( surface.bitmap.bitmapData,mat,colorTform,blend,clipRect,image_filtering_enabled );
		}else{
			bitmapData.copyPixels( surface.bitmap.bitmapData,surface.rect,new Point( x,y ) );
		}
		return 0;
	}

	public function DrawSurface2( surface:gxtkSurface,x:Number,y:Number,srcx:int,srcy:int,srcw:int,srch:int ):int{
		if( srcw<0 ){ srcx+=srcw;srcw=-srcw; }
		if( srch<0 ){ srcy+=srch;srch=-srch; }
		if( srcw<=0 || srch<=0 ) return 0;
		
		UseBitmap();

		var srcrect:Rectangle=new Rectangle( srcx,srcy,srcw,srch );
		
		if( matrix || clipRect || colorTform || blend ){

			var scratch:BitmapData=surface.scratch;
			if( scratch==null || srcw!=scratch.width || srch!=scratch.height ){
				if( scratch!=null ) scratch.dispose();
				scratch=new BitmapData( srcw,srch );
				surface.scratch=scratch;
			}
			scratch.copyPixels( surface.bitmap.bitmapData,srcrect,new Point( 0,0 ) );
			
			var mmatrix:Matrix=matrix;
			if( mmatrix==null ){
				mmatrix=new Matrix( 1,0,0,1,x,y );
			}else if( x!=0 || y!=0 ){
				//have to translate matrix! TODO!
				return -1;
			}

			bitmapData.draw( scratch,mmatrix,colorTform,blend,clipRect,image_filtering_enabled );
		}else{
			bitmapData.copyPixels( surface.bitmap.bitmapData,srcrect,new Point( x,y ) );
		}
		return 0;
	}
	
	public function ReadPixels( pixels:Array,x:int,y:int,width:int,height:int,offset:int,pitch:int ):int{
	
		UseBitmap();
		
		var data:ByteArray=bitmapData.getPixels( new Rectangle( x,y,width,height ) );
		data.position=0;
		
		var px:int,py:int,j:int=offset,argb:int;
		
		for( py=0;py<height;++py ){
			for( px=0;px<width;++px ){
				pixels[j++]=data.readInt();
			}
			j+=pitch-width;
		}
		
		return 0;
	}
	
	public function WritePixels2( surface:gxtkSurface,pixels:Array,x:int,y:int,width:int,height:int,offset:int,pitch:int ):int{

		UseBitmap();
		
		var data:ByteArray=new ByteArray();
		data.length=width*height;
			
		var px:int,py:int,j:int=offset,argb:int;
		
		for( py=0;py<height;++py ){
			for( px=0;px<width;++px ){
				data.writeInt( pixels[j++] );
			}
			j+=pitch-width;
		}
		data.position=0;
		
		surface.bitmap.bitmapData.setPixels( new Rectangle( x,y,width,height ),data );
		
		return 0;
	}
}

//***** gxtkSurface *****

class gxtkSurface{
	internal var bitmap:Bitmap;
	internal var rect:Rectangle;
	internal var scratch:BitmapData;
	
	function gxtkSurface( bitmap:Bitmap ){
		this.bitmap=bitmap;
		rect=new Rectangle( 0,0,bitmap.width,bitmap.height );
	}

	//***** GXTK API *****

	public function Discard():int{
		return 0;
	}
	
	public function Width():int{
		return rect.width;
	}

	public function Height():int{
		return rect.height;
	}

	public function Loaded():int{
		return 1;
	}
}

class gxtkInput{

	internal var KEY_LMB:int=1;
	internal var KEY_TOUCH0:int=0x180;

	internal var keyStates:Array=new Array( 512 );
	internal var charQueue:Array=new Array( 32 );
	internal var charPut:int=0;
	internal var charGet:int=0;
	internal var mouseX:Number=0;
	internal var mouseY:Number=0;
	
	function gxtkInput(){
	
		for( var i:int=0;i<512;++i ){
			keyStates[i]=0;
		}

		var stage:Stage=game.stage;
	
		stage.addEventListener( KeyboardEvent.KEY_DOWN,function( e:KeyboardEvent ):void{
			OnKeyDown( e.keyCode );
			if( e.charCode!=0 ){
				PutChar( e.charCode );
			}else{
				var chr:int=KeyToChar( e.keyCode );
				if( chr ) PutChar( chr );
			}
		} );
		
		stage.addEventListener( KeyboardEvent.KEY_UP,function( e:KeyboardEvent ):void{
			OnKeyUp( e.keyCode );
		} );
		
		stage.addEventListener( MouseEvent.MOUSE_DOWN,function( e:MouseEvent ):void{
			OnKeyDown( KEY_LMB );
		} );
		
		stage.addEventListener( MouseEvent.MOUSE_UP,function( e:MouseEvent ):void{
			OnKeyUp( KEY_LMB );
		} );
		
		stage.addEventListener( MouseEvent.MOUSE_MOVE,function( e:MouseEvent ):void{
			OnMouseMove( e.localX,e.localY );
		} );
	}
	
	internal function KeyToChar( key:int ):int{
		switch( key ){
		case 8:case 9:case 13:case 27:
			return key;
		case 33:case 34:case 35:case 36:case 37:case 38:case 39:case 40:case 45:
			return key | 0x10000;
		case 46:
			return 127;
		}
		return 0;
	}
	
	internal function BeginUpdate():void{
	}
	
	internal function EndUpdate():void{
		for( var i:int=0;i<512;++i ){
			keyStates[i]&=0x100;
		}
		charGet=0;
		charPut=0;
	}
	
	internal function OnKeyDown( key:int ):void{
		if( (keyStates[key]&0x100)==0 ){
			keyStates[key]|=0x100;
			++keyStates[key];
		}
	}

	internal function OnKeyUp( key:int ):void{
		keyStates[key]&=0xff;
	}
	
	internal function PutChar( chr:int ):void{
		if( chr==0 ) return;
		if( charPut-charGet<32 ){
			charQueue[charPut & 31]=chr;
			charPut+=1;
		}
	}
	
	internal function OnMouseMove( x:Number,y:Number ):void{
		mouseX=x;
		mouseY=y;
	}

	//***** GXTK API *****
	
	public function SetKeyboardEnabled( enabled:int ):int{
		return 0;
	}
	
	public function KeyDown( key:int ):int{
		if( key>0 && key<512 ){
			if( key==KEY_TOUCH0 ) key=KEY_LMB;
			return keyStates[key] >> 8;
		}
		return 0;
	}

	public function KeyHit( key:int ):int{
		if( key>0 && key<512 ){
			if( key==KEY_TOUCH0 ) key=KEY_LMB;
			return keyStates[key] & 0xff;
		}
		return 0;
	}

	public function GetChar():int{
		if( charGet!=charPut ){
			var chr:int=charQueue[charGet & 31];
			charGet+=1;
			return chr;
		}
		return 0;
	}
	
	public function MouseX():Number{
		return mouseX;
	}

	public function MouseY():Number{
		return mouseY;
	}

	public function JoyX( index:int ):Number{
		return 0;
	}
	
	public function JoyY( index:int ):Number{
		return 0;
	}
	
	public function JoyZ( index:int ):Number{
		return 0;
	}
	
	public function TouchX( index:int ):Number{
		return mouseX;
	}

	public function TouchY( index:int ):Number{
		return mouseY;
	}
	
	public function AccelX():Number{
		return 0;
	}
	
	public function AccelY():Number{
		return 0;
	}
	
	public function AccelZ():Number{
		return 0;
	}
}

class gxtkChannel{
	internal var channel:SoundChannel;	//null then not playing
	internal var sample:gxtkSample;
	internal var loops:int;
	internal var transform:SoundTransform=new SoundTransform();
	internal var pausepos:Number;
	internal var state:int;
}

class gxtkAudio{

	internal var music:gxtkSample;

	internal var channels:Array=new Array( 33 );

	internal var loop_kludge:int=1;

	function gxtkAudio(){
		for( var i:int=0;i<33;++i ){
			channels[i]=new gxtkChannel();
		}
	}
	
	internal function OnSuspend():void{
		for( var i:int=0;i<33;++i ){
			var chan:gxtkChannel=channels[i];
			if( chan.state==1 ){
				chan.pausepos=chan.channel.position;
				chan.channel.stop();
			}
		}
	}
	
	internal function OnResume():void{
		for( var i:int=0;i<33;++i ){
			var chan:gxtkChannel=channels[i];
			if( chan.state==1 ){
				if( loop_kludge ){
					chan.channel=chan.sample.sound.play( chan.pausepos,0,chan.transform );
					if( chan.loops ) chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
				}else{
					chan.channel=chan.sample.sound.play( chan.pausepos,chan.loops,chan.transform );
				}
			}
		}
	}
	
	internal function SoundComplete( ev:Event ):void{
		if( !loop_kludge ) return;
		for( var i:int=0;i<33;++i ){
			var chan:gxtkChannel=channels[i];
			if( chan.state==1 && chan.channel==ev.target && chan.loops ){
				chan.channel=chan.sample.sound.play( 0,0,chan.transform );
				chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
				break;
			}
		}
	}
	
	//***** GXTK API *****
	
	public function LoadSample( path:String ):gxtkSample{
		var sound:Sound=game.loadSound( path );
		if( sound ) return new gxtkSample( sound );
		return null;
	}
	
	public function PlaySample( sample:gxtkSample,channel:int,flags:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		if( chan.state!=0 ) chan.channel.stop();

		chan.sample=sample;
		chan.loops=flags ? 0x7fffffff : 0;
		chan.state=1;
		if( loop_kludge ){
			chan.channel=sample.sound.play( 0,0,chan.transform );
			chan.channel.addEventListener( Event.SOUND_COMPLETE,SoundComplete );
		}else{
			chan.channel=sample.sound.play( 0,chan.loops,chan.transform );
		}

		return 0;
	}
	
	public function StopChannel( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		if( chan.state!=0 ){
			chan.channel.stop();
			chan.channel=null;
			chan.sample=null;
			chan.state=0;
		}
		return 0;
	}
	
	public function PauseChannel( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		if( chan.state==1 ){
			chan.pausepos=chan.channel.position;
			chan.channel.stop();
			chan.state=2;
		}
		return 0;
	}
	
	public function ResumeChannel( channel:int ):int{
		var chan:gxtkChannel=channels[channel];
		
		if( chan.state==2 ){
			chan.channel=chan.sample.sound.play( chan.pausepos,chan.loops,chan.transform );
			chan.state=1;
		}
		return 0;
	}
	
	public function ChannelState( channel:int ):int{
		return -1;
	}
	
	public function SetVolume( channel:int,volume:Number ):int{
		var chan:gxtkChannel=channels[channel];
		
		chan.transform.volume=volume;

		if( chan.state!=0 ) chan.channel.soundTransform=chan.transform;

		return 0;
	}
	
	public function SetPan( channel:int,pan:Number ):int{
		var chan:gxtkChannel=channels[channel];
		
		chan.transform.pan=pan;

		if( chan.state!=0 ) chan.channel.soundTransform=chan.transform;

		return 0;
	}
	
	public function SetRate( channel:int,rate:Number ):int{
		return -1;
	}
	
	public function PlayMusic( path:String,flags:int ):int{
		StopMusic();
		
		music=LoadSample( path );
		if( !music ) return -1;
		
		PlaySample( music,32,flags );
		return 0;
	}
	
	public function StopMusic():int{
		StopChannel( 32 );
		
		if( music ){
			music.Discard();
			music=null;
		}
		return 0;
	}
	
	public function PauseMusic():int{
		PauseChannel( 32 );
		
		return 0;
	}
	
	public function ResumeMusic():int{
		ResumeChannel( 32 );
		
		return 0;
	}
	
	public function MusicState():int{
		return ChannelState( 32 );
	}
	
	public function SetMusicVolume( volume:Number ):int{
		SetVolume( 32,volume );
		return 0;
	}
}

class gxtkSample{

	internal var sound:Sound;

	function gxtkSample( sound:Sound ){
		this.sound=sound;
	}
	
	public function Discard():int{
		return 0;
	}
	
}
class bb_app_App extends Object{
	public function fg_App_new():bb_app_App{
		bb_app_device=(new bb_app_AppDevice).fg_AppDevice_new(this);
		return this;
	}
	public function m_OnCreate():int{
		return 0;
	}
	public function m_OnUpdate():int{
		return 0;
	}
	public function m_OnSuspend():int{
		return 0;
	}
	public function m_OnResume():int{
		return 0;
	}
	public function m_OnRender():int{
		return 0;
	}
	public function m_OnLoading():int{
		return 0;
	}
}
class bb_bpb_BPB extends bb_app_App{
	public function fg_BPB_new():bb_bpb_BPB{
		super.fg_App_new();
		return this;
	}
	internal static var g_Z:bb_graphics_Image;
	internal static var g_twi:bb_graphics_Image;
	internal static var g_unicorn:bb_graphics_Image;
	internal static var g_pegasus:bb_graphics_Image;
	internal static var g_earth:bb_graphics_Image;
	internal static var g_explode:bb_graphics_Image;
	internal static var g_mask:bb_graphics_Image;
	internal static var g_mainscreen:bb_graphics_Image;
	internal static var g_instructions:bb_graphics_Image;
	internal static var g_commands:bb_graphics_Image;
	internal static var g_gameover:bb_graphics_Image;
	internal static var g_gametype:Array;
	internal static var g_gametick:int;
	internal static var g_player:bb_bpb_ball;
	public function m_newgame():int{
		bb_bpb_ball.fg_flush();
		bb_bpb_platform.fg_flush();
		bb_bpb_ball.g_limit2=(new bb_bpb_platform).fg_platform_new(320.0,240.0,500.0);
		(new bb_bpb_platform).fg_platform_new(320.0,240.0,300.0);
		bb_bpb_ball.g_limit1=(new bb_bpb_platform).fg_platform_new(320.0,240.0,100.0);
		g_player=(new bb_bpb_ball).fg_ball_new(320.0,240.0,0.0,20.0,2.0,0.2,0);
		g_gametick=0;
		return 0;
	}
	public override function m_OnCreate():int{
		g_Z=bb_graphics_LoadImage("Z1007.png",1,bb_graphics_Image.g_DefaultFlags);
		g_twi=bb_graphics_LoadImage("main.png",1,bb_graphics_Image.g_DefaultFlags);
		g_unicorn=bb_graphics_LoadImage("unicorn.png",1,bb_graphics_Image.g_DefaultFlags);
		g_pegasus=bb_graphics_LoadImage("pegasus.png",1,bb_graphics_Image.g_DefaultFlags);
		g_earth=bb_graphics_LoadImage("normal.png",1,bb_graphics_Image.g_DefaultFlags);
		g_explode=bb_graphics_LoadImage("explode.png",1,bb_graphics_Image.g_DefaultFlags);
		g_mask=bb_graphics_LoadImage("main.png",1,bb_graphics_Image.g_DefaultFlags);
		g_mainscreen=bb_graphics_LoadImage("mainscreen.png",1,bb_graphics_Image.g_DefaultFlags);
		g_instructions=bb_graphics_LoadImage("instructions.png",1,bb_graphics_Image.g_DefaultFlags);
		g_commands=bb_graphics_LoadImage("buttons.png",1,bb_graphics_Image.g_DefaultFlags);
		bb_bpb_button.fg_init();
		g_gameover=bb_graphics_LoadImage("gameover.png",1,bb_graphics_Image.g_DefaultFlags);
		g_gametype=[g_twi,g_unicorn,g_pegasus,g_earth];
		g_gametick=0;
		bb_app_SetUpdateRate(50);
		this.m_newgame();
		bb_bpb_ball.g_autoplay=1;
		return 0;
	}
	internal static var g_gamestatus:int;
	public function m_updategame(t_mx:int,t_my:int,t_md:int):int{
		g_gametick=g_gametick+1;
		bb_bpb_ball.fg_updateall(t_mx,t_my,t_md,0);
		bb_bpb_ball.fg_moveall();
		var t_delay:int=48;
		if(g_gametick>1500){
			t_delay=40;
		}
		if(g_gametick>3000){
			t_delay=32;
		}
		if(g_gametick>4500){
			t_delay=24;
		}
		if(g_gametick>6000){
			t_delay=16;
		}
		if(g_gametick>7500){
			t_delay=8;
		}
		if(g_gametick % t_delay==0){
			bb_bpb_ball.fg_generate();
		}
		return 0;
	}
	public override function m_OnUpdate():int{
		var t_mx:int=((bb_input_MouseX())|0);
		var t_my:int=((bb_input_MouseY())|0);
		var t_md:int=bb_input_MouseDown(0);
		var t_mc:int=bb_input_MouseHit(0);
		if(g_gamestatus==0){
			if((bb_bpb_button.fg_updatebutton(1,0,420,t_mx,t_my,t_mc))!=0){
				g_gamestatus=1;
			}
			if((bb_bpb_button.fg_updatebutton(0,340,420,t_mx,t_my,t_mc))!=0){
				g_gamestatus=2;
				bb_bpb_ball.g_autoplay=0;
				this.m_newgame();
			}
		}else{
			if(g_gamestatus==1){
				if((bb_bpb_button.fg_updatebutton(2,0,420,t_mx,t_my,t_mc))!=0){
					g_gamestatus=0;
				}
			}
		}
		if((bb_bpb_ball.g_autoplay)!=0){
			if(g_player.f_status>50){
				this.m_newgame();
			}else{
				this.m_updategame(t_mx,t_my,t_md);
			}
		}else{
			if((bb_input_KeyHit(13))!=0){
				this.m_newgame();
			}
			if((bb_input_KeyDown(32))!=0){
				bb_bpb_ball.g_main.f_requestshield=1;
			}else{
				bb_bpb_ball.g_main.f_requestshield=0;
			}
			if(g_player.f_status<99){
				this.m_updategame(t_mx,t_my,t_md);
			}else{
				if((bb_bpb_button.fg_updatebutton(3,170,380,t_mx,t_my,t_mc))!=0){
					this.m_newgame();
				}else{
					if((bb_input_KeyHit(27))!=0){
						this.m_newgame();
						g_gamestatus=0;
						bb_bpb_ball.g_autoplay=1;
					}
				}
			}
		}
		return 0;
	}
	internal static var g_camerax:Number;
	internal static var g_cameray:Number;
	public override function m_OnRender():int{
		bb_graphics_Cls(128.0,0.0,0.0);
		g_camerax=g_player.f_x-320.0;
		g_cameray=g_player.f_y-240.0;
		bb_bpb_platform.fg_renderall(((g_camerax)|0),((g_cameray)|0));
		bb_bpb_ball.fg_renderall(g_camerax,g_cameray);
		if(g_player.f_status==99){
			bb_graphics_SetAlpha(0.75);
			bb_graphics_SetColor(0.0,0.0,0.0);
			bb_graphics_DrawRect(0.0,0.0,640.0,480.0);
			bb_graphics_SetAlpha(1.0);
			bb_graphics_SetColor(255.0,255.0,255.0);
			bb_graphics_SetColor(0.0,0.0,0.0);
			bb_graphics_DrawImage(g_gameover,10.0,10.0,0);
			bb_graphics_SetColor(255.0,255.0,255.0);
			bb_graphics_DrawImage(g_gameover,0.0,0.0,0);
			bb_graphics_DrawText("You lasted: "+bb_bpb_timing(g_gametick),150.0,330.0,0.0,0.0);
			bb_graphics_DrawText("And you have sent "+String(bb_bpb_ball.g_kills)+" ponies back to Equestria.",150.0,350.0,0.0,0.0);
			bb_graphics_DrawText("Click retry or hit ENTER to try again",200.0,430.0,0.0,0.0);
			bb_graphics_DrawText("Press Escape to return to main menu",200.0,450.0,0.0,0.0);
			bb_bpb_button.fg_drawbutton(3,170,380);
		}else{
			if(bb_bpb_ball.g_autoplay==0){
				bb_graphics_DrawText("Survival Time : "+bb_bpb_timing(g_gametick),10.0,10.0,0.0,0.0);
				bb_graphics_DrawText("Ponies released : "+String(bb_bpb_ball.g_kills),10.0,30.0,0.0,0.0);
				bb_bpb_drawbox(10,50,251,13);
				if(bb_bpb_ball.g_main.f_shield>0){
					bb_graphics_SetColor(255.0,0.0,0.0);
					bb_graphics_DrawRect(11.0,52.0,(bb_bpb_ball.g_main.f_shield),10.0);
					bb_graphics_SetColor(255.0,255.0,255.0);
				}
			}else{
				if(g_gamestatus==0){
					bb_graphics_SetColor(0.0,0.0,0.0);
					bb_graphics_DrawImage(g_mainscreen,10.0,10.0,0);
					bb_graphics_SetColor(255.0,255.0,255.0);
					bb_graphics_DrawImage(g_mainscreen,0.0,0.0,0);
					bb_bpb_button.fg_drawbutton(1,0,420);
					bb_bpb_button.fg_drawbutton(0,340,420);
				}
				if(g_gamestatus==1){
					bb_graphics_SetAlpha(0.75);
					bb_graphics_SetColor(0.0,0.0,0.0);
					bb_graphics_DrawRect(0.0,0.0,640.0,480.0);
					bb_graphics_SetAlpha(1.0);
					bb_graphics_SetColor(255.0,255.0,255.0);
					bb_graphics_DrawImage(g_instructions,0.0,0.0,0);
					bb_bpb_button.fg_drawbutton(2,0,420);
				}
			}
		}
		return 0;
	}
}
class bb_app_AppDevice extends gxtkApp{
	internal var f_app:bb_app_App=null;
	public function fg_AppDevice_new(t_app:bb_app_App):bb_app_AppDevice{
		this.f_app=t_app;
		bb_graphics_SetGraphicsContext((new bb_graphics_GraphicsContext).fg_GraphicsContext_new(this.GraphicsDevice()));
		bb_input_SetInputDevice(this.InputDevice());
		bb_audio_SetAudioDevice(this.AudioDevice());
		return this;
	}
	public function fg_AppDevice_new2():bb_app_AppDevice{
		return this;
	}
	public override function OnCreate():int{
		bb_graphics_SetFont(null,32);
		return this.f_app.m_OnCreate();
	}
	public override function OnUpdate():int{
		return this.f_app.m_OnUpdate();
	}
	public override function OnSuspend():int{
		return this.f_app.m_OnSuspend();
	}
	public override function OnResume():int{
		return this.f_app.m_OnResume();
	}
	public override function OnRender():int{
		bb_graphics_BeginRender();
		var t_r:int=this.f_app.m_OnRender();
		bb_graphics_EndRender();
		return t_r;
	}
	public override function OnLoading():int{
		bb_graphics_BeginRender();
		var t_r:int=this.f_app.m_OnLoading();
		bb_graphics_EndRender();
		return t_r;
	}
	internal var f_updateRate:int=0;
	public override function SetUpdateRate(t_hertz:int):int{
		super.SetUpdateRate(t_hertz);
		this.f_updateRate=t_hertz;
		return 0;
	}
}
class bb_graphics_GraphicsContext extends Object{
	internal var f_device:gxtkGraphics=null;
	public function fg_GraphicsContext_new(t_device:gxtkGraphics):bb_graphics_GraphicsContext{
		this.f_device=t_device;
		return this;
	}
	public function fg_GraphicsContext_new2():bb_graphics_GraphicsContext{
		return this;
	}
	internal var f_defaultFont:bb_graphics_Image=null;
	internal var f_font:bb_graphics_Image=null;
	internal var f_firstChar:int=0;
	internal var f_matrixSp:int=0;
	internal var f_ix:Number=1.0;
	internal var f_iy:Number=.0;
	internal var f_jx:Number=.0;
	internal var f_jy:Number=1.0;
	internal var f_tx:Number=.0;
	internal var f_ty:Number=.0;
	internal var f_tformed:int=0;
	internal var f_matDirty:int=0;
	internal var f_color_r:Number=.0;
	internal var f_color_g:Number=.0;
	internal var f_color_b:Number=.0;
	internal var f_alpha:Number=.0;
	internal var f_blend:int=0;
	internal var f_scissor_x:Number=.0;
	internal var f_scissor_y:Number=.0;
	internal var f_scissor_width:Number=.0;
	internal var f_scissor_height:Number=.0;
	internal var f_matrixStack:Array=new_number_array(192);
}
var bb_graphics_context:bb_graphics_GraphicsContext;
internal function bb_graphics_SetGraphicsContext(t_gc:bb_graphics_GraphicsContext):int{
	bb_graphics_context=t_gc;
	return 0;
}
var bb_input_device:gxtkInput;
internal function bb_input_SetInputDevice(t_dev:gxtkInput):int{
	bb_input_device=t_dev;
	return 0;
}
var bb_audio_device:gxtkAudio;
internal function bb_audio_SetAudioDevice(t_dev:gxtkAudio):int{
	bb_audio_device=t_dev;
	return 0;
}
var bb_app_device:bb_app_AppDevice;
internal function bbMain():int{
	(new bb_bpb_BPB).fg_BPB_new();
	return 0;
}
class bb_graphics_Image extends Object{
	internal static var g_DefaultFlags:int;
	public function fg_Image_new():bb_graphics_Image{
		return this;
	}
	internal var f_surface:gxtkSurface=null;
	internal var f_width:int=0;
	internal var f_height:int=0;
	internal var f_frames:Array=[];
	internal var f_flags:int=0;
	internal var f_tx:Number=.0;
	internal var f_ty:Number=.0;
	public function m_SetHandle(t_tx:Number,t_ty:Number):int{
		this.f_tx=t_tx;
		this.f_ty=t_ty;
		this.f_flags=this.f_flags&-2;
		return 0;
	}
	public function m_ApplyFlags(t_iflags:int):int{
		this.f_flags=t_iflags;
		if((this.f_flags&2)!=0){
			var t_:Array=this.f_frames;
			var t_2:int=0;
			while(t_2<t_.length){
				var t_f:bb_graphics_Frame=t_[t_2];
				t_2=t_2+1;
				t_f.f_x+=1;
			}
			this.f_width-=2;
		}
		if((this.f_flags&4)!=0){
			var t_3:Array=this.f_frames;
			var t_4:int=0;
			while(t_4<t_3.length){
				var t_f2:bb_graphics_Frame=t_3[t_4];
				t_4=t_4+1;
				t_f2.f_y+=1;
			}
			this.f_height-=2;
		}
		if((this.f_flags&1)!=0){
			this.m_SetHandle((this.f_width)/2.0,(this.f_height)/2.0);
		}
		if(this.f_frames.length==1 && this.f_frames[0].f_x==0 && this.f_frames[0].f_y==0 && this.f_width==this.f_surface.Width() && this.f_height==this.f_surface.Height()){
			this.f_flags|=65536;
		}
		return 0;
	}
	public function m_Load(t_path:String,t_nframes:int,t_iflags:int):bb_graphics_Image{
		this.f_surface=bb_graphics_context.f_device.LoadSurface(t_path);
		if(!((this.f_surface)!=null)){
			return null;
		}
		this.f_width=((this.f_surface.Width()/t_nframes)|0);
		this.f_height=this.f_surface.Height();
		this.f_frames=new_object_array(t_nframes);
		for(var t_i:int=0;t_i<t_nframes;t_i=t_i+1){
			this.f_frames[t_i]=(new bb_graphics_Frame).fg_Frame_new(t_i*this.f_width,0);
		}
		this.m_ApplyFlags(t_iflags);
		return this;
	}
	internal var f_source:bb_graphics_Image=null;
	public function m_Grab(t_x:int,t_y:int,t_iwidth:int,t_iheight:int,t_nframes:int,t_iflags:int,t_source:bb_graphics_Image):bb_graphics_Image{
		this.f_source=t_source;
		this.f_surface=t_source.f_surface;
		this.f_width=t_iwidth;
		this.f_height=t_iheight;
		this.f_frames=new_object_array(t_nframes);
		var t_ix:int=t_x;
		var t_iy:int=t_y;
		for(var t_i:int=0;t_i<t_nframes;t_i=t_i+1){
			if(t_ix+this.f_width>t_source.f_width){
				t_ix=0;
				t_iy+=this.f_height;
			}
			if(t_ix+this.f_width>t_source.f_width || t_iy+this.f_height>t_source.f_height){
				error("Image frame outside surface");
			}
			this.f_frames[t_i]=(new bb_graphics_Frame).fg_Frame_new(t_ix+t_source.f_frames[0].f_x,t_iy+t_source.f_frames[0].f_y);
			t_ix+=this.f_width;
		}
		this.m_ApplyFlags(t_iflags);
		return this;
	}
	public function m_GrabImage(t_x:int,t_y:int,t_width:int,t_height:int,t_frames:int,t_flags:int):bb_graphics_Image{
		if(this.f_frames.length!=1){
			return null;
		}
		return ((new bb_graphics_Image).fg_Image_new()).m_Grab(t_x,t_y,t_width,t_height,t_frames,t_flags,this);
	}
	public function m_Width():int{
		return this.f_width;
	}
	public function m_Height():int{
		return this.f_height;
	}
	public function m_Frames():int{
		return this.f_frames.length;
	}
}
class bb_graphics_Frame extends Object{
	internal var f_x:int=0;
	internal var f_y:int=0;
	public function fg_Frame_new(t_x:int,t_y:int):bb_graphics_Frame{
		this.f_x=t_x;
		this.f_y=t_y;
		return this;
	}
	public function fg_Frame_new2():bb_graphics_Frame{
		return this;
	}
}
internal function bb_graphics_LoadImage(t_path:String,t_frameCount:int,t_flags:int):bb_graphics_Image{
	return ((new bb_graphics_Image).fg_Image_new()).m_Load(t_path,t_frameCount,t_flags);
}
internal function bb_graphics_LoadImage2(t_path:String,t_frameWidth:int,t_frameHeight:int,t_frameCount:int,t_flags:int):bb_graphics_Image{
	var t_atlas:bb_graphics_Image=((new bb_graphics_Image).fg_Image_new()).m_Load(t_path,1,0);
	if((t_atlas)!=null){
		return t_atlas.m_GrabImage(0,0,t_frameWidth,t_frameHeight,t_frameCount,t_flags);
	}
	return null;
}
internal function bb_graphics_SetFont(t_font:bb_graphics_Image,t_firstChar:int):int{
	if(!((t_font)!=null)){
		if(!((bb_graphics_context.f_defaultFont)!=null)){
			bb_graphics_context.f_defaultFont=bb_graphics_LoadImage("mojo_font.png",96,2);
		}
		t_font=bb_graphics_context.f_defaultFont;
		t_firstChar=32;
	}
	bb_graphics_context.f_font=t_font;
	bb_graphics_context.f_firstChar=t_firstChar;
	return 0;
}
var bb_graphics_renderDevice:gxtkGraphics;
internal function bb_graphics_SetMatrix(t_ix:Number,t_iy:Number,t_jx:Number,t_jy:Number,t_tx:Number,t_ty:Number):int{
	bb_graphics_context.f_ix=t_ix;
	bb_graphics_context.f_iy=t_iy;
	bb_graphics_context.f_jx=t_jx;
	bb_graphics_context.f_jy=t_jy;
	bb_graphics_context.f_tx=t_tx;
	bb_graphics_context.f_ty=t_ty;
	bb_graphics_context.f_tformed=((t_ix!=1.0 || t_iy!=0.0 || t_jx!=0.0 || t_jy!=1.0 || t_tx!=0.0 || t_ty!=0.0)?1:0);
	bb_graphics_context.f_matDirty=1;
	return 0;
}
internal function bb_graphics_SetMatrix2(t_m:Array):int{
	bb_graphics_SetMatrix(t_m[0],t_m[1],t_m[2],t_m[3],t_m[4],t_m[5]);
	return 0;
}
internal function bb_graphics_SetColor(t_r:Number,t_g:Number,t_b:Number):int{
	bb_graphics_context.f_color_r=t_r;
	bb_graphics_context.f_color_g=t_g;
	bb_graphics_context.f_color_b=t_b;
	bb_graphics_context.f_device.SetColor(t_r,t_g,t_b);
	return 0;
}
internal function bb_graphics_SetAlpha(t_alpha:Number):int{
	bb_graphics_context.f_alpha=t_alpha;
	bb_graphics_context.f_device.SetAlpha(t_alpha);
	return 0;
}
internal function bb_graphics_SetBlend(t_blend:int):int{
	bb_graphics_context.f_blend=t_blend;
	bb_graphics_context.f_device.SetBlend(t_blend);
	return 0;
}
internal function bb_graphics_DeviceWidth():int{
	return bb_graphics_context.f_device.Width();
}
internal function bb_graphics_DeviceHeight():int{
	return bb_graphics_context.f_device.Height();
}
internal function bb_graphics_SetScissor(t_x:Number,t_y:Number,t_width:Number,t_height:Number):int{
	bb_graphics_context.f_scissor_x=t_x;
	bb_graphics_context.f_scissor_y=t_y;
	bb_graphics_context.f_scissor_width=t_width;
	bb_graphics_context.f_scissor_height=t_height;
	bb_graphics_context.f_device.SetScissor(((t_x)|0),((t_y)|0),((t_width)|0),((t_height)|0));
	return 0;
}
internal function bb_graphics_BeginRender():int{
	if(!((bb_graphics_context.f_device.Mode())!=0)){
		return 0;
	}
	bb_graphics_renderDevice=bb_graphics_context.f_device;
	bb_graphics_context.f_matrixSp=0;
	bb_graphics_SetMatrix(1.0,0.0,0.0,1.0,0.0,0.0);
	bb_graphics_SetColor(255.0,255.0,255.0);
	bb_graphics_SetAlpha(1.0);
	bb_graphics_SetBlend(0);
	bb_graphics_SetScissor(0.0,0.0,(bb_graphics_DeviceWidth()),(bb_graphics_DeviceHeight()));
	return 0;
}
internal function bb_graphics_EndRender():int{
	bb_graphics_renderDevice=null;
	return 0;
}
class bb_bpb_button extends Object{
	internal static var g_list:bb_graphics_Image;
	public function fg_button_new():bb_bpb_button{
		return this;
	}
	internal static var g_all:Array;
	internal var f_id:int=0;
	internal var f_img:bb_graphics_Image=null;
	public static function fg_init():int{
		g_list=bb_bpb_BPB.g_commands;
		var t_i:int=0;
		for(t_i=0;t_i<=3;t_i=t_i+1){
			g_all[t_i]=(new bb_bpb_button).fg_button_new();
			g_all[t_i].f_id=t_i;
			g_all[t_i].f_img=g_list.m_GrabImage(50,5+50*t_i,300,45,1,bb_graphics_Image.g_DefaultFlags);
		}
		return 0;
	}
	internal var f_hover:int=0;
	internal static var g_width:int;
	internal static var g_height:int;
	public function m_update(t_x:int,t_y:int,t_mx:int,t_my:int,t_mc:int):int{
		this.f_hover=0;
		if(t_x<t_mx && t_mx<t_x+g_width && t_y<t_my && t_my<t_y+g_height){
			this.f_hover=1;
		}
		if(((t_mc)!=0) && ((this.f_hover)!=0)){
			return 1;
		}
		return 0;
	}
	public static function fg_updatebutton(t_i:int,t_x:int,t_y:int,t_mx:int,t_my:int,t_mc:int):int{
		return g_all[t_i].m_update(t_x,t_y,t_mx,t_my,t_mc);
	}
	public function m_draw(t_x:int,t_y:int):int{
		if((this.f_hover)!=0){
			bb_graphics_SetColor(255.0,0.0,0.0);
		}else{
			bb_graphics_SetColor(255.0,255.0,255.0);
		}
		bb_graphics_DrawImage(this.f_img,(t_x),(t_y),0);
		bb_graphics_SetColor(255.0,255.0,255.0);
		return 0;
	}
	public static function fg_drawbutton(t_i:int,t_x:int,t_y:int):int{
		g_all[t_i].m_draw(t_x,t_y);
		return 0;
	}
}
internal function bb_app_SetUpdateRate(t_hertz:int):int{
	return bb_app_device.SetUpdateRate(t_hertz);
}
class bb_bpb_ball extends Object{
	internal static var g_main:bb_bpb_ball;
	internal static var g_limit1:bb_bpb_platform;
	internal static var g_limit2:bb_bpb_platform;
	internal static var g_kills:int;
	internal static var g_count:int;
	internal static var g_all:Array;
	public static function fg_flush():int{
		g_main=null;
		g_limit1=null;
		g_limit2=null;
		g_kills=0;
		var t_i:int=0;
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			g_all[t_i]=null;
		}
		g_count=0;
		return 0;
	}
	internal var f_x:Number=.0;
	internal var f_y:Number=.0;
	internal var f_angle:Number=.0;
	internal var f_size:Number=.0;
	internal var f_kind:int=0;
	internal var f_mass:Number=.0;
	internal var f_speed:Number=.0;
	internal var f_status:int=0;
	public function fg_ball_new(t_px:Number,t_py:Number,t_a:Number,t_s:Number,t_m:Number,t_sp:Number,t_k:int):bb_bpb_ball{
		this.f_x=t_px;
		this.f_y=t_py;
		this.f_angle=t_a;
		this.f_size=t_s;
		this.f_kind=t_k;
		this.f_mass=t_m;
		this.f_speed=t_sp;
		g_all[g_count]=this;
		g_count=g_count+1;
		this.f_status=0;
		if(this.f_kind==0){
			g_main=this;
		}
		return this;
	}
	public function fg_ball_new2():bb_bpb_ball{
		return this;
	}
	internal static var g_autoplay:int;
	public function m_outofboundary():int{
		var t_distx:Number=this.f_x-g_limit2.f_x;
		var t_disty:Number=this.f_y-g_limit2.f_y;
		var t_maxsize:Number=g_limit2.f_size-this.f_size;
		if(t_distx*t_distx+t_disty*t_disty>t_maxsize*t_maxsize){
			return 1;
		}
		return 0;
	}
	internal var f_dx:Number=.0;
	internal var f_dy:Number=.0;
	public function m_trust():int{
		if(this.f_status!=50){
			return 0;
		}
		var t_addx:Number=Math.cos((this.f_angle)*D2R)*this.f_speed;
		var t_addy:Number=Math.sin((this.f_angle)*D2R)*this.f_speed;
		this.f_dx+=t_addx;
		this.f_dy+=t_addy;
		return 0;
	}
	internal var f_shielded:int=0;
	internal var f_shield:int=250;
	internal var f_requestshield:int=0;
	public function m_update2(t_mx:int,t_my:int,t_md:int,t_md2:int):int{
		if(this.f_status!=50 || ((this.m_outofboundary())!=0)){
			this.f_status+=1;
		}
		if((g_autoplay)!=0){
			this.f_angle=(Math.atan2(g_limit2.f_y+Math.sin((bb_bpb_BPB.g_gametick)*D2R)*100.0-this.f_y,g_limit2.f_x+Math.cos((bb_bpb_BPB.g_gametick)*D2R)*100.0-this.f_x)*R2D);
			this.m_trust();
		}else{
			this.f_shielded=0;
			if(this.f_shield>0 && ((this.f_requestshield)!=0) && this.f_status==50){
				this.f_shielded=1;
			}
			if(this.f_shielded==1){
				this.f_shield=this.f_shield-1;
			}
			this.f_angle=(Math.atan2((t_my-240),(t_mx-320))*R2D);
			if((t_md)!=0){
				this.m_trust();
			}
		}
		return 0;
	}
	public function m_updateai():int{
		if(this.f_status!=50 || ((this.m_outofboundary())!=0)){
			this.f_status+=1;
		}
		if(this.f_status==51){
			g_kills+=1;
		}
		this.f_requestshield=0;
		if(this.f_shield>0 && this.f_kind==1){
			this.f_requestshield=1;
		}
		this.f_shielded=0;
		if(this.f_shield>0 && ((this.f_requestshield)!=0) && this.f_status==50){
			this.f_shielded=1;
		}
		if(this.f_shielded==1){
			this.f_shield=this.f_shield-1;
		}
		this.f_angle=(Math.atan2(g_main.f_y-this.f_y,g_main.f_x-this.f_x)*R2D);
		this.m_trust();
		return 0;
	}
	public static function fg_updateall(t_mx:int,t_my:int,t_md:int,t_md2:int):int{
		var t_i:int=0;
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			if(g_all[t_i].f_status>=100){
				continue;
			}
			if(g_all[t_i].f_kind==0){
				g_all[t_i].m_update2(t_mx,t_my,t_md,t_md2);
			}else{
				g_all[t_i].m_updateai();
			}
		}
		return 0;
	}
	public function m_move():int{
		if(this.f_status<50){
			return 0;
		}
		this.f_x=this.f_x+this.f_dx;
		this.f_y=this.f_y+this.f_dy;
		this.f_dx=0.98*this.f_dx;
		this.f_dy=0.98*this.f_dy;
		return 0;
	}
	public function m_colliding(t_b:bb_bpb_ball):int{
		if(t_b==this){
			return 0;
		}
		if(t_b.f_status!=50){
			return 0;
		}
		var t_minimum:Number=this.f_size+t_b.f_size;
		var t_distx:Number=this.f_x-t_b.f_x;
		var t_disty:Number=this.f_y-t_b.f_y;
		var t_sq:Number=t_minimum*t_minimum;
		var t_dist:Number=t_distx*t_distx+t_disty*t_disty;
		if(t_dist<=t_sq){
			return 1;
		}
		return 0;
	}
	public function m_bounce(t_addx:Number,t_addy:Number):int{
		if((this.f_shielded)!=0){
			return 0;
		}
		this.f_dx+=t_addx;
		this.f_dy+=t_addy;
		return 0;
	}
	public function m_collide():int{
		if(this.f_status!=50){
			return 0;
		}
		var t_i:int=0;
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			var t_b:bb_bpb_ball=g_all[t_i];
			if((this.m_colliding(t_b))!=0){
				var t_normal:Number=(Math.atan2(t_b.f_y-this.f_y,t_b.f_x-this.f_x)*R2D);
				var t_distx:Number=this.f_x-t_b.f_x;
				var t_disty:Number=this.f_y-t_b.f_y;
				var t_dist:Number=Math.sqrt(t_distx*t_distx+t_disty*t_disty);
				var t_cdist:Number=this.f_size+t_b.f_size;
				var t_mdist1:Number=(t_cdist-t_dist)*(t_b.f_mass/(this.f_mass+t_b.f_mass));
				var t_mdist2:Number=(t_cdist-t_dist)*(this.f_mass/(this.f_mass+t_b.f_mass));
				this.f_x+=t_mdist1*Math.cos((t_normal+180.0)*D2R);
				this.f_y+=t_mdist1*Math.sin((t_normal+180.0)*D2R);
				t_b.f_x+=t_mdist2*Math.cos((t_normal)*D2R);
				t_b.f_y+=t_mdist2*Math.sin((t_normal)*D2R);
				var t_nx:Number=Math.cos((t_normal)*D2R);
				var t_ny:Number=Math.sin((t_normal)*D2R);
				var t_a1:Number=this.f_dx*t_nx+this.f_dy*t_ny;
				var t_a2:Number=t_b.f_dx*t_nx+t_b.f_dy*t_ny;
				var t_opt:Number=2.0*(t_a1-t_a2)/(t_b.f_mass+this.f_mass);
				this.m_bounce(-t_opt*t_nx*t_b.f_mass*1.2,-t_opt*t_ny*t_b.f_mass*1.2);
				t_b.m_bounce(t_opt*t_nx*t_b.f_mass*1.2,t_opt*t_ny*t_b.f_mass*1.2);
			}
		}
		return 0;
	}
	public static function fg_moveall():int{
		var t_i:int=0;
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			if(g_all[t_i].f_status>=100){
				continue;
			}
			g_all[t_i].m_move();
			g_all[t_i].m_collide();
		}
		return 0;
	}
	public static function fg_generate():int{
		var t_angle:Number=bb_random_Rnd3(360.0);
		var t_specy:int=((bb_random_Rnd3(50.0))|0) % 3;
		var t_distance:Number=bb_random_Rnd3(g_limit2.f_size-g_limit1.f_size)+g_limit1.f_size;
		var t_posx:Number=Math.cos((t_angle)*D2R)*t_distance+g_limit2.f_x;
		var t_posy:Number=Math.sin((t_angle)*D2R)*t_distance+g_limit2.f_y;
		var t_size:Number=bb_random_Rnd3(20.0)+10.0;
		var t_mass:Number=t_size/10.0;
		var t_speed:Number=bb_random_Rnd3(0.3)+0.1;
		if(t_specy==1){
			t_mass=t_mass*0.5;
			t_speed=t_speed*1.5;
		}
		if(t_specy==2){
			t_mass=t_mass*1.5;
			t_speed=t_speed*0.5;
		}
		(new bb_bpb_ball).fg_ball_new(t_posx,t_posy,bb_random_Rnd3(360.0),t_size,t_mass,t_speed,1+t_specy);
		return 0;
	}
	public function m_draw2(t_cx:Number,t_cy:Number):int{
		var t_a:Number=this.f_angle+Math.cos((bb_bpb_BPB.g_gametick*8)*D2R)*2.0;
		var t_usedsize:Number=this.f_size;
		if(this.f_status<50){
			t_usedsize=this.f_size*(1.0+(50-this.f_status)/5.0);
		}
		bb_graphics_SetAlpha(1.0-(bb_math_Abs(this.f_status-50))/50.0);
		if(this.f_kind==0){
			bb_bpb_drawrotatedscaled(bb_bpb_BPB.g_gametype[0],this.f_x-t_cx,this.f_y-t_cy,1.5*t_usedsize/20.0,t_a);
		}else{
			bb_bpb_drawrotatedscaled(bb_bpb_BPB.g_gametype[this.f_kind],this.f_x-t_cx,this.f_y-t_cy,1.5*t_usedsize/20.0,t_a);
		}
		bb_graphics_SetAlpha(1.0);
		if(this.f_status>50){
			if(this.f_kind==0){
				t_usedsize=(this.f_status-50)/5.0;
			}else{
				t_usedsize=(25.0-bb_math_Abs2((this.f_status)-75.0))/20.0;
			}
			bb_bpb_drawrotatedscaled(bb_bpb_BPB.g_explode,this.f_x-t_cx,this.f_y-t_cy,t_usedsize,t_a+(bb_bpb_BPB.g_gametick*4));
		}
		if((this.f_shielded)!=0){
			bb_graphics_SetColor(255.0,0.0,0.0);
			bb_graphics_SetAlpha(0.5);
			bb_graphics_DrawCircle(this.f_x-t_cx,this.f_y-t_cy,this.f_size*2.0);
			bb_graphics_SetAlpha(1.0);
			bb_graphics_SetColor(255.0,255.0,255.0);
		}
		return 0;
	}
	public static function fg_renderall(t_cx:Number,t_cy:Number):int{
		var t_i:int=0;
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			if(g_all[t_i].f_status>=100){
				continue;
			}
			g_all[t_i].m_draw2(t_cx,t_cy);
		}
		return 0;
	}
}
class bb_bpb_platform extends Object{
	internal static var g_count:int;
	internal static var g_all:Array;
	public static function fg_flush():int{
		var t_i:int=0;
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			g_all[t_i]=null;
		}
		g_count=0;
		return 0;
	}
	internal var f_x:Number=.0;
	internal var f_y:Number=.0;
	internal var f_size:Number=.0;
	public function fg_platform_new(t_px:Number,t_py:Number,t_s:Number):bb_bpb_platform{
		this.f_x=t_px;
		this.f_y=t_py;
		this.f_size=t_s;
		g_all[g_count]=this;
		g_count=g_count+1;
		return this;
	}
	public function fg_platform_new2():bb_bpb_platform{
		return this;
	}
	public function m_draw(t_cx:int,t_cy:int):int{
		bb_graphics_DrawCircle(this.f_x-(t_cx),this.f_y-(t_cy),this.f_size);
		return 0;
	}
	public static function fg_renderall(t_cx:int,t_cy:int):int{
		var t_i:int=0;
		bb_graphics_SetColor(0.0,128.0,255.0);
		bb_graphics_SetAlpha(0.5);
		for(t_i=0;t_i<=g_count-1;t_i=t_i+1){
			g_all[t_i].m_draw(t_cx,t_cy);
		}
		bb_graphics_SetColor(255.0,255.0,255.0);
		bb_graphics_SetAlpha(1.0);
		return 0;
	}
}
internal function bb_input_MouseX():Number{
	return bb_input_device.MouseX();
}
internal function bb_input_MouseY():Number{
	return bb_input_device.MouseY();
}
internal function bb_input_MouseDown(t_button:int):int{
	return bb_input_device.KeyDown(1+t_button);
}
internal function bb_input_MouseHit(t_button:int):int{
	return bb_input_device.KeyHit(1+t_button);
}
var bb_random_Seed:int;
internal function bb_random_Rnd():Number{
	bb_random_Seed=bb_random_Seed*1664525+1013904223|0;
	return (bb_random_Seed>>8&16777215)/16777216.0;
}
internal function bb_random_Rnd2(t_low:Number,t_high:Number):Number{
	return bb_random_Rnd3(t_high-t_low)+t_low;
}
internal function bb_random_Rnd3(t_range:Number):Number{
	return bb_random_Rnd()*t_range;
}
internal function bb_input_KeyHit(t_key:int):int{
	return bb_input_device.KeyHit(t_key);
}
internal function bb_input_KeyDown(t_key:int):int{
	return bb_input_device.KeyDown(t_key);
}
internal function bb_graphics_Cls(t_r:Number,t_g:Number,t_b:Number):int{
	bb_graphics_renderDevice.Cls(t_r,t_g,t_b);
	return 0;
}
internal function bb_graphics_ValidateMatrix():int{
	if((bb_graphics_context.f_matDirty)!=0){
		bb_graphics_context.f_device.SetMatrix(bb_graphics_context.f_ix,bb_graphics_context.f_iy,bb_graphics_context.f_jx,bb_graphics_context.f_jy,bb_graphics_context.f_tx,bb_graphics_context.f_ty);
		bb_graphics_context.f_matDirty=0;
	}
	return 0;
}
internal function bb_graphics_DrawCircle(t_x:Number,t_y:Number,t_r:Number):int{
	bb_graphics_ValidateMatrix();
	bb_graphics_renderDevice.DrawOval(t_x-t_r,t_y-t_r,t_r*2.0,t_r*2.0);
	return 0;
}
internal function bb_math_Abs(t_x:int):int{
	if(t_x>=0){
		return t_x;
	}
	return -t_x;
}
internal function bb_math_Abs2(t_x:Number):Number{
	if(t_x>=0.0){
		return t_x;
	}
	return -t_x;
}
internal function bb_graphics_PushMatrix():int{
	var t_sp:int=bb_graphics_context.f_matrixSp;
	bb_graphics_context.f_matrixStack[t_sp+0]=bb_graphics_context.f_ix;
	bb_graphics_context.f_matrixStack[t_sp+1]=bb_graphics_context.f_iy;
	bb_graphics_context.f_matrixStack[t_sp+2]=bb_graphics_context.f_jx;
	bb_graphics_context.f_matrixStack[t_sp+3]=bb_graphics_context.f_jy;
	bb_graphics_context.f_matrixStack[t_sp+4]=bb_graphics_context.f_tx;
	bb_graphics_context.f_matrixStack[t_sp+5]=bb_graphics_context.f_ty;
	bb_graphics_context.f_matrixSp=t_sp+6;
	return 0;
}
internal function bb_graphics_Transform(t_ix:Number,t_iy:Number,t_jx:Number,t_jy:Number,t_tx:Number,t_ty:Number):int{
	var t_ix2:Number=t_ix*bb_graphics_context.f_ix+t_iy*bb_graphics_context.f_jx;
	var t_iy2:Number=t_ix*bb_graphics_context.f_iy+t_iy*bb_graphics_context.f_jy;
	var t_jx2:Number=t_jx*bb_graphics_context.f_ix+t_jy*bb_graphics_context.f_jx;
	var t_jy2:Number=t_jx*bb_graphics_context.f_iy+t_jy*bb_graphics_context.f_jy;
	var t_tx2:Number=t_tx*bb_graphics_context.f_ix+t_ty*bb_graphics_context.f_jx+bb_graphics_context.f_tx;
	var t_ty2:Number=t_tx*bb_graphics_context.f_iy+t_ty*bb_graphics_context.f_jy+bb_graphics_context.f_ty;
	bb_graphics_SetMatrix(t_ix2,t_iy2,t_jx2,t_jy2,t_tx2,t_ty2);
	return 0;
}
internal function bb_graphics_Transform2(t_m:Array):int{
	bb_graphics_Transform(t_m[0],t_m[1],t_m[2],t_m[3],t_m[4],t_m[5]);
	return 0;
}
internal function bb_graphics_Translate(t_x:Number,t_y:Number):int{
	bb_graphics_Transform(1.0,0.0,0.0,1.0,t_x,t_y);
	return 0;
}
internal function bb_graphics_Rotate(t_angle:Number):int{
	bb_graphics_Transform(Math.cos((t_angle)*D2R),-Math.sin((t_angle)*D2R),Math.sin((t_angle)*D2R),Math.cos((t_angle)*D2R),0.0,0.0);
	return 0;
}
internal function bb_graphics_Scale(t_x:Number,t_y:Number):int{
	bb_graphics_Transform(t_x,0.0,0.0,t_y,0.0,0.0);
	return 0;
}
internal function bb_graphics_PopMatrix():int{
	var t_sp:int=bb_graphics_context.f_matrixSp-6;
	bb_graphics_SetMatrix(bb_graphics_context.f_matrixStack[t_sp+0],bb_graphics_context.f_matrixStack[t_sp+1],bb_graphics_context.f_matrixStack[t_sp+2],bb_graphics_context.f_matrixStack[t_sp+3],bb_graphics_context.f_matrixStack[t_sp+4],bb_graphics_context.f_matrixStack[t_sp+5]);
	bb_graphics_context.f_matrixSp=t_sp;
	return 0;
}
internal function bb_graphics_DrawImage(t_image:bb_graphics_Image,t_x:Number,t_y:Number,t_frame:int):int{
	var t_f:bb_graphics_Frame=t_image.f_frames[t_frame];
	if((bb_graphics_context.f_tformed)!=0){
		bb_graphics_PushMatrix();
		bb_graphics_Translate(t_x-t_image.f_tx,t_y-t_image.f_ty);
		bb_graphics_ValidateMatrix();
		if((t_image.f_flags&65536)!=0){
			bb_graphics_context.f_device.DrawSurface(t_image.f_surface,0.0,0.0);
		}else{
			bb_graphics_context.f_device.DrawSurface2(t_image.f_surface,0.0,0.0,t_f.f_x,t_f.f_y,t_image.f_width,t_image.f_height);
		}
		bb_graphics_PopMatrix();
	}else{
		bb_graphics_ValidateMatrix();
		if((t_image.f_flags&65536)!=0){
			bb_graphics_context.f_device.DrawSurface(t_image.f_surface,t_x-t_image.f_tx,t_y-t_image.f_ty);
		}else{
			bb_graphics_context.f_device.DrawSurface2(t_image.f_surface,t_x-t_image.f_tx,t_y-t_image.f_ty,t_f.f_x,t_f.f_y,t_image.f_width,t_image.f_height);
		}
	}
	return 0;
}
internal function bb_graphics_DrawImage2(t_image:bb_graphics_Image,t_x:Number,t_y:Number,t_rotation:Number,t_scaleX:Number,t_scaleY:Number,t_frame:int):int{
	var t_f:bb_graphics_Frame=t_image.f_frames[t_frame];
	bb_graphics_PushMatrix();
	bb_graphics_Translate(t_x,t_y);
	bb_graphics_Rotate(t_rotation);
	bb_graphics_Scale(t_scaleX,t_scaleY);
	bb_graphics_Translate(-t_image.f_tx,-t_image.f_ty);
	bb_graphics_ValidateMatrix();
	if((t_image.f_flags&65536)!=0){
		bb_graphics_context.f_device.DrawSurface(t_image.f_surface,0.0,0.0);
	}else{
		bb_graphics_context.f_device.DrawSurface2(t_image.f_surface,0.0,0.0,t_f.f_x,t_f.f_y,t_image.f_width,t_image.f_height);
	}
	bb_graphics_PopMatrix();
	return 0;
}
internal function bb_bpb_drawrotatedscaled(t_img:bb_graphics_Image,t_px:Number,t_py:Number,t_scale:Number,t_angle:Number):int{
	if(t_scale==0.0){
		return 0;
	}
	var t_a:Number=-t_angle-90.0;
	bb_graphics_PushMatrix();
	bb_graphics_Translate(t_px,t_py);
	bb_graphics_Rotate(t_a);
	bb_graphics_Scale(t_scale,t_scale);
	bb_graphics_Translate(-t_px,-t_py);
	t_img.m_SetHandle(32.0,32.0);
	bb_graphics_DrawImage(t_img,t_px,t_py,0);
	bb_graphics_PopMatrix();
	return 0;
}
internal function bb_graphics_DrawRect(t_x:Number,t_y:Number,t_w:Number,t_h:Number):int{
	bb_graphics_ValidateMatrix();
	bb_graphics_renderDevice.DrawRect(t_x,t_y,t_w,t_h);
	return 0;
}
internal function bb_bpb_timing(t_octet:int):String{
	if(t_octet==1){
		t_octet=0;
	}
	var t_totalcenti:int=t_octet*2;
	var t_mins:int=((t_totalcenti/6000)|0);
	var t_secs:int=((t_totalcenti/100)|0)-t_mins*60;
	var t_centi:int=t_totalcenti-t_mins*6000-t_secs*100;
	var t_strmin:String="0"+String(t_mins);
	var t_strsec:String="0"+String(t_secs);
	var t_strcen:String="0"+String(t_centi);
	var t_tps:String=t_strmin.slice(-2)+":"+t_strsec.slice(-2)+"'"+t_strcen.slice(-2);
	return t_tps;
}
internal function bb_graphics_DrawText(t_text:String,t_x:Number,t_y:Number,t_xalign:Number,t_yalign:Number):int{
	if(!((bb_graphics_context.f_font)!=null)){
		return 0;
	}
	var t_w:int=bb_graphics_context.f_font.m_Width();
	var t_h:int=bb_graphics_context.f_font.m_Height();
	t_x-=Math.floor((t_w*t_text.length)*t_xalign);
	t_y-=Math.floor((t_h)*t_yalign);
	for(var t_i:int=0;t_i<t_text.length;t_i=t_i+1){
		var t_ch:int=t_text.charCodeAt(t_i)-bb_graphics_context.f_firstChar;
		if(t_ch>=0 && t_ch<bb_graphics_context.f_font.m_Frames()){
			bb_graphics_DrawImage(bb_graphics_context.f_font,t_x+(t_i*t_w),t_y,t_ch);
		}
	}
	return 0;
}
internal function bb_graphics_DrawLine(t_x1:Number,t_y1:Number,t_x2:Number,t_y2:Number):int{
	bb_graphics_ValidateMatrix();
	bb_graphics_renderDevice.DrawLine(t_x1,t_y1,t_x2,t_y2);
	return 0;
}
internal function bb_bpb_drawbox(t_x:int,t_y:int,t_w:int,t_h:int):int{
	bb_graphics_DrawLine((t_x),(t_y),(t_x+t_w),(t_y));
	bb_graphics_DrawLine((t_x),(t_y),(t_x),(t_y+t_h));
	bb_graphics_DrawLine((t_x),(t_y+t_h),(t_x+t_w),(t_y+t_h));
	bb_graphics_DrawLine((t_x+t_w),(t_y),(t_x+t_w),(t_y+t_h));
	return 0;
}
function bbInit():void{
	bb_graphics_context=null;
	bb_input_device=null;
	bb_audio_device=null;
	bb_app_device=null;
	bb_graphics_Image.g_DefaultFlags=0;
	bb_graphics_renderDevice=null;
	bb_bpb_BPB.g_Z=null;
	bb_bpb_BPB.g_twi=null;
	bb_bpb_BPB.g_unicorn=null;
	bb_bpb_BPB.g_pegasus=null;
	bb_bpb_BPB.g_earth=null;
	bb_bpb_BPB.g_explode=null;
	bb_bpb_BPB.g_mask=null;
	bb_bpb_BPB.g_mainscreen=null;
	bb_bpb_BPB.g_instructions=null;
	bb_bpb_BPB.g_commands=null;
	bb_bpb_button.g_list=null;
	bb_bpb_button.g_all=new_object_array(4);
	bb_bpb_BPB.g_gameover=null;
	bb_bpb_BPB.g_gametype=[];
	bb_bpb_BPB.g_gametick=0;
	bb_bpb_ball.g_main=null;
	bb_bpb_ball.g_limit1=null;
	bb_bpb_ball.g_limit2=null;
	bb_bpb_ball.g_kills=0;
	bb_bpb_ball.g_count=0;
	bb_bpb_ball.g_all=new_object_array(2048);
	bb_bpb_platform.g_count=0;
	bb_bpb_platform.g_all=new_object_array(32);
	bb_bpb_BPB.g_player=null;
	bb_bpb_ball.g_autoplay=0;
	bb_bpb_BPB.g_gamestatus=0;
	bb_bpb_button.g_width=300;
	bb_bpb_button.g_height=45;
	bb_random_Seed=1234;
	bb_bpb_BPB.g_camerax=.0;
	bb_bpb_BPB.g_cameray=.0;
}
//${TRANSCODE_END}
