
//Change this to true for a stretchy canvas!
//
var RESIZEABLE_CANVAS=false;

//Start us up!
//
window.onload=function( e ){

	if( RESIZEABLE_CANVAS ){
		window.onresize=function( e ){
			var canvas=document.getElementById( "GameCanvas" );

			//This vs window.innerWidth, which apparently doesn't account for scrollbar?
			var width=document.body.clientWidth;
			
			//This vs document.body.clientHeight, which does weird things - document seems to 'grow'...perhaps canvas resize pushing page down?
			var height=window.innerHeight;			

			canvas.width=width;
			canvas.height=height;
		}
		window.onresize( null );
	}
	
	game_canvas=document.getElementById( "GameCanvas" );
	
	game_console=document.getElementById( "GameConsole" );

	try{
	
		bbInit();
		bbMain();
		
		if( game_runner!=null ) game_runner();
		
	}catch( err ){
	
		alertError( err );
	}
}

var game_canvas;
var game_console;
var game_runner;

//${CONFIG_BEGIN}
CFG_CONFIG="release";
CFG_HOST="winnt";
CFG_IMAGE_FILES="*.png|*.jpg";
CFG_LANG="js";
CFG_MOJO_AUTO_SUSPEND_ENABLED="false";
CFG_MUSIC_FILES="*.wav|*.ogg|*.mp3|*.m4a";
CFG_OPENGL_GLES20_ENABLED="false";
CFG_PARSER_FUNC_ATTRS="0";
CFG_SOUND_FILES="*.wav|*.ogg|*.mp3|*.m4a";
CFG_TARGET="html5";
CFG_TEXT_FILES="*.txt|*.xml|*.json";
//${CONFIG_END}

//${METADATA_BEGIN}
var META_DATA="[mojo_font.png];type=image/png;width=864;height=13;\n[buttons.png];type=image/png;width=400;height=200;\n[explode.png];type=image/png;width=64;height=64;\n[gameover.png];type=image/png;width=640;height=330;\n[instructions.png];type=image/png;width=640;height=480;\n[main.png];type=image/png;width=64;height=64;\n[mainscreen.png];type=image/png;width=640;height=480;\n[mask.png];type=image/png;width=64;height=64;\n[normal.png];type=image/png;width=64;height=64;\n[pegasus.png];type=image/png;width=64;height=64;\n[twiball.png];type=image/png;width=286;height=332;\n[unicorn.png];type=image/png;width=64;height=64;\n";
//${METADATA_END}

function getMetaData( path,key ){
	var i=META_DATA.indexOf( "["+path+"]" );
	if( i==-1 ) return "";
	i+=path.length+2;

	var e=META_DATA.indexOf( "\n",i );
	if( e==-1 ) e=META_DATA.length;

	i=META_DATA.indexOf( ";"+key+"=",i )
	if( i==-1 || i>=e ) return "";
	i+=key.length+2;

	e=META_DATA.indexOf( ";",i );
	if( e==-1 ) return "";

	return META_DATA.slice( i,e );
}

function loadString( path ){
	var xhr=new XMLHttpRequest();
	xhr.open( "GET","data/"+path,false );
	xhr.send( null );
	if( (xhr.status==200) || (xhr.status==0) ) return xhr.responseText;
	return "";
}

function loadImage( path,onloadfun ){
	var ty=getMetaData( path,"type" );
	if( ty.indexOf( "image/" )!=0 ) return null;

	var image=new Image();
	
	image.meta_width=parseInt( getMetaData( path,"width" ) );
	image.meta_height=parseInt( getMetaData( path,"height" ) );
	image.onload=onloadfun;
	image.src="data/"+path;
	
	return image;
}

function loadAudio( path ){
	var audio=new Audio( "data/"+path );
	return audio;
}

//${TRANSCODE_BEGIN}

// Javascript Monkey runtime.
//
// Placed into the public domain 24/02/2011.
// No warranty implied; use at your own risk.

//***** JavaScript Runtime *****

var D2R=0.017453292519943295;
var R2D=57.29577951308232;

var err_info="";
var err_stack=[];

var dbg_index=0;

function push_err(){
	err_stack.push( err_info );
}

function pop_err(){
	err_info=err_stack.pop();
}

function stackTrace(){
	if( !err_info.length ) return "";
	var str=err_info+"\n";
	for( var i=err_stack.length-1;i>0;--i ){
		str+=err_stack[i]+"\n";
	}
	return str;
}

function print( str ){
	if( game_console ){
		game_console.value+=str+"\n";
		game_console.scrollTop = game_console.scrollHeight - game_console.clientHeight;
	}
	if( window.console!=undefined ){
		window.console.log( str );
	}
	return 0;
}

function alertError( err ){
	if( typeof(err)=="string" && err=="" ) return;
	alert( "Monkey Runtime Error : "+err.toString()+"\n\n"+stackTrace() );
}

function error( err ){
	throw err;
}

function debugLog( str ){
	print( str );
}

function debugStop(){
	error( "STOP" );
}

function dbg_object( obj ){
	if( obj ) return obj;
	error( "Null object access" );
}

function dbg_array( arr,index ){
	if( index<0 || index>=arr.length ) error( "Array index out of range" );
	dbg_index=index;
	return arr;
}

function new_bool_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=false;
	return arr;
}

function new_number_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=0;
	return arr;
}

function new_string_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]='';
	return arr;
}

function new_array_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=[];
	return arr;
}

function new_object_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=null;
	return arr;
}

function resize_bool_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=false;
	return arr;
}

function resize_number_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=0;
	return arr;
}

function resize_string_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]="";
	return arr;
}

function resize_array_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=[];
	return arr;
}

function resize_object_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=null;
	return arr;
}

function string_compare( lhs,rhs ){
	var n=Math.min( lhs.length,rhs.length ),i,t;
	for( i=0;i<n;++i ){
		t=lhs.charCodeAt(i)-rhs.charCodeAt(i);
		if( t ) return t;
	}
	return lhs.length-rhs.length;
}

function string_replace( str,find,rep ){	//no unregex replace all?!?
	var i=0;
	for(;;){
		i=str.indexOf( find,i );
		if( i==-1 ) return str;
		str=str.substring( 0,i )+rep+str.substring( i+find.length );
		i+=rep.length;
	}
}

function string_trim( str ){
	var i=0,i2=str.length;
	while( i<i2 && str.charCodeAt(i)<=32 ) i+=1;
	while( i2>i && str.charCodeAt(i2-1)<=32 ) i2-=1;
	return str.slice( i,i2 );
}

function string_starts_with( str,substr ){
	return substr.length<=str.length && str.slice(0,substr.length)==substr;
}

function string_ends_with( str,substr ){
	return substr.length<=str.length && str.slice(str.length-substr.length,str.length)==substr;
}

function string_from_chars( chars ){
	var str="",i;
	for( i=0;i<chars.length;++i ){
		str+=String.fromCharCode( chars[i] );
	}
	return str;
}


function object_downcast( obj,clas ){
	if( obj instanceof clas ) return obj;
	return null;
}

function object_implements( obj,iface ){
	if( obj && obj.implments && obj.implments[iface] ) return obj;
	return null;
}

function extend_class( clas ){
	var tmp=function(){};
	tmp.prototype=clas.prototype;
	return new tmp;
}

function ThrowableObject(){
}

ThrowableObject.prototype.toString=function(){ 
	return "Uncaught Monkey Exception"; 
}

// HTML5 mojo runtime.
//
// Copyright 2011 Mark Sibly, all rights reserved.
// No warranty implied; use at your own risk.

var gl=null;	//global WebGL context - a bit rude!

KEY_LMB=1;
KEY_RMB=2;
KEY_MMB=3;
KEY_TOUCH0=0x180;

function eatEvent( e ){
	if( e.stopPropagation ){
		e.stopPropagation();
		e.preventDefault();
	}else{
		e.cancelBubble=true;
		e.returnValue=false;
	}
}

function keyToChar( key ){
	switch( key ){
	case 8:
	case 9:
	case 13:
	case 27:
	case 32:
		return key;
	case 33:
	case 34:
	case 35:
	case 36:
	case 37:
	case 38:
	case 39:
	case 40:
	case 45:
		return key | 0x10000;
	case 46:
		return 127;
	}
	return 0;
}

//***** gxtkApp class *****

function gxtkApp(){

	if( typeof( CFG_OPENGL_GLES20_ENABLED )!="undefined" && CFG_OPENGL_GLES20_ENABLED=="true" ){
		this.gl=game_canvas.getContext( "webgl" );
		if( !this.gl ) this.gl=game_canvas.getContext( "experimental-webgl" );
	}else{
		this.gl=null;
	}

	this.graphics=new gxtkGraphics( this,game_canvas );
	this.input=new gxtkInput( this );
	this.audio=new gxtkAudio( this );

	this.loading=0;
	this.maxloading=0;

	this.updateRate=0;
	this.startMillis=(new Date).getTime();
	
	this.dead=false;
	this.suspended=false;
	
	var app=this;
	var canvas=game_canvas;
	
	function gxtkMain(){
	
		var input=app.input;
	
		canvas.onkeydown=function( e ){
			input.OnKeyDown( e.keyCode );
			var chr=keyToChar( e.keyCode );
			if( chr ) input.PutChar( chr );
			if( e.keyCode<48 || (e.keyCode>111 && e.keyCode<122) ) eatEvent( e );
		}

		canvas.onkeyup=function( e ){
			input.OnKeyUp( e.keyCode );
		}

		canvas.onkeypress=function( e ){
			if( e.charCode ){
				input.PutChar( e.charCode );
			}else if( e.which ){
				input.PutChar( e.which );
			}
		}

		canvas.onmousedown=function( e ){
			switch( e.button ){
			case 0:input.OnKeyDown( KEY_LMB );break;
			case 1:input.OnKeyDown( KEY_MMB );break;
			case 2:input.OnKeyDown( KEY_RMB );break;
			}
			eatEvent( e );
		}
		
		canvas.onmouseup=function( e ){
			switch( e.button ){
			case 0:input.OnKeyUp( KEY_LMB );break;
			case 1:input.OnKeyUp( KEY_MMB );break;
			case 2:input.OnKeyUp( KEY_RMB );break;
			}
			eatEvent( e );
		}
		
		canvas.onmouseout=function( e ){
			input.OnKeyUp( KEY_LMB );
			input.OnKeyUp( KEY_MMB );
			input.OnKeyUp( KEY_RMB );
			eatEvent( e );
		}

		canvas.onmousemove=function( e ){
			var x=e.clientX+document.body.scrollLeft;
			var y=e.clientY+document.body.scrollTop;
			var c=canvas;
			while( c ){
				x-=c.offsetLeft;
				y-=c.offsetTop;
				c=c.offsetParent;
			}
			input.OnMouseMove( x,y );
			eatEvent( e );
		}

		canvas.onfocus=function( e ){
			if( CFG_MOJO_AUTO_SUSPEND_ENABLED=="true" ){
				app.InvokeOnResume();
			}
		}
		
		canvas.onblur=function( e ){
			if( CFG_MOJO_AUTO_SUSPEND_ENABLED=="true" ){
				app.InvokeOnSuspend();
			}
		}
		
		canvas.ontouchstart=function( e ){
			for( var i=0;i<e.changedTouches.length;++i ){
				var touch=e.changedTouches[i];
				var x=touch.pageX;
				var y=touch.pageY;
				var c=canvas;
				while( c ){
					x-=c.offsetLeft;
					y-=c.offsetTop;
					c=c.offsetParent;
				}
				input.OnTouchStart( touch.identifier,x,y );
			}
			eatEvent( e );
		}
		
		canvas.ontouchmove=function( e ){
			for( var i=0;i<e.changedTouches.length;++i ){
				var touch=e.changedTouches[i];
				var x=touch.pageX;
				var y=touch.pageY;
				var c=canvas;
				while( c ){
					x-=c.offsetLeft;
					y-=c.offsetTop;
					c=c.offsetParent;
				}
				input.OnTouchMove( touch.identifier,x,y );
			}
			eatEvent( e );
		}
		
		canvas.ontouchend=function( e ){
			for( var i=0;i<e.changedTouches.length;++i ){
				input.OnTouchEnd( e.changedTouches[i].identifier );
			}
			eatEvent( e );
		}
		
		window.ondevicemotion=function( e ){
			var tx=e.accelerationIncludingGravity.x/9.81;
			var ty=e.accelerationIncludingGravity.y/9.81;
			var tz=e.accelerationIncludingGravity.z/9.81;
			var x,y;
			switch( window.orientation ){
			case   0:x=+tx;y=-ty;break;
			case 180:x=-tx;y=+ty;break;
			case  90:x=-ty;y=-tx;break;
			case -90:x=+ty;y=+tx;break;
			}
			input.OnDeviceMotion( x,y,tz );
			eatEvent( e );
		}

		canvas.focus();

		app.InvokeOnCreate();
		app.InvokeOnRender();
	}

	game_runner=gxtkMain;
}

var timerSeq=0;

gxtkApp.prototype.SetFrameRate=function( fps ){

	var seq=++timerSeq;
	
	if( !fps ) return;
	
	var app=this;
	var updatePeriod=1000.0/fps;
	var nextUpdate=(new Date).getTime()+updatePeriod;
	
	function timeElapsed(){
		if( seq!=timerSeq ) return;

		var time;		
		var updates=0;

		for(;;){
			nextUpdate+=updatePeriod;

			app.InvokeOnUpdate();
			if( seq!=timerSeq ) return;
			
			if( nextUpdate>(new Date).getTime() ) break;
			
			if( ++updates==7 ){
				nextUpdate=(new Date).getTime();
				break;
			}
		}
		app.InvokeOnRender();
		if( seq!=timerSeq ) return;
			
		var delay=nextUpdate-(new Date).getTime();
		setTimeout( timeElapsed,delay>0 ? delay : 0 );
	}
	
	setTimeout( timeElapsed,updatePeriod );
}

gxtkApp.prototype.IncLoading=function(){
	++this.loading;
	if( this.loading>this.maxloading ) this.maxloading=this.loading;
	if( this.loading==1 ) this.SetFrameRate( 0 );
}

gxtkApp.prototype.DecLoading=function(){
	--this.loading;
	if( this.loading!=0 ) return;
	this.maxloading=0;
	this.SetFrameRate( this.updateRate );
}

gxtkApp.prototype.GetMetaData=function( path,key ){
	return getMetaData( path,key );
}

gxtkApp.prototype.Die=function( err ){
	this.dead=true;
	this.audio.OnSuspend();
	alertError( err );
}

gxtkApp.prototype.InvokeOnCreate=function(){
	if( this.dead ) return;
	
	try{
		gl=this.gl;
		this.OnCreate();
		gl=null;
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnUpdate=function(){
	if( this.dead || this.suspended || !this.updateRate || this.loading ) return;
	
	try{
		gl=this.gl;
		this.input.BeginUpdate();
		this.OnUpdate();		
		this.input.EndUpdate();
		gl=null;
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnSuspend=function(){
	if( this.dead || this.suspended ) return;
	
	try{
		gl=this.gl;
		this.suspended=true;
		this.OnSuspend();
		this.audio.OnSuspend();
		gl=null;
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnResume=function(){
	if( this.dead || !this.suspended ) return;
	
	try{
		gl=this.gl;
		this.audio.OnResume();
		this.OnResume();
		this.suspended=false;
		gl=null;
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnRender=function(){
	if( this.dead || this.suspended ) return;
	
	try{
		gl=this.gl;
		this.graphics.BeginRender();
		if( this.loading ){
			this.OnLoading();
		}else{
			this.OnRender();
		}
		this.graphics.EndRender();
		gl=null;
	}catch( ex ){
		this.Die( ex );
	}
}

//***** GXTK API *****

gxtkApp.prototype.GraphicsDevice=function(){
	return this.graphics;
}

gxtkApp.prototype.InputDevice=function(){
	return this.input;
}

gxtkApp.prototype.AudioDevice=function(){
	return this.audio;
}

gxtkApp.prototype.AppTitle=function(){
	return document.URL;
}

gxtkApp.prototype.LoadState=function(){
	var state=localStorage.getItem( ".mojostate@"+document.URL );
	if( state ) return state;
	return "";
}

gxtkApp.prototype.SaveState=function( state ){
	localStorage.setItem( ".mojostate@"+document.URL,state );
}

gxtkApp.prototype.LoadString=function( path ){
	return loadString( path );
}

gxtkApp.prototype.SetUpdateRate=function( fps ){
	this.updateRate=fps;
	
	if( !this.loading ) this.SetFrameRate( fps );
}

gxtkApp.prototype.MilliSecs=function(){
	return ((new Date).getTime()-this.startMillis)|0;
}

gxtkApp.prototype.Loading=function(){
	return this.loading;
}

gxtkApp.prototype.OnCreate=function(){
}

gxtkApp.prototype.OnUpdate=function(){
}

gxtkApp.prototype.OnSuspend=function(){
}

gxtkApp.prototype.OnResume=function(){
}

gxtkApp.prototype.OnRender=function(){
}

gxtkApp.prototype.OnLoading=function(){
}

//***** gxtkGraphics class *****

function gxtkGraphics( app,canvas ){
	this.app=app;
	this.canvas=canvas;
	this.gc=canvas.getContext( '2d' );
	this.tmpCanvas=null;
	this.r=255;
	this.b=255;
	this.g=255;
	this.white=true;
	this.color="rgb(255,255,255)"
	this.alpha=1;
	this.blend="source-over";
	this.ix=1;this.iy=0;
	this.jx=0;this.jy=1;
	this.tx=0;this.ty=0;
	this.tformed=false;
	this.scissorX=0;
	this.scissorY=0;
	this.scissorWidth=0;
	this.scissorHeight=0;
	this.clipped=false;
}

gxtkGraphics.prototype.BeginRender=function(){
	if( this.gc ) this.gc.save();
}

gxtkGraphics.prototype.EndRender=function(){
	if( this.gc ) this.gc.restore();
}

gxtkGraphics.prototype.Mode=function(){
	if( this.gc ) return 1;
	return 0;
}

gxtkGraphics.prototype.Width=function(){
	return this.canvas.width;
}

gxtkGraphics.prototype.Height=function(){
	return this.canvas.height;
}

gxtkGraphics.prototype.LoadSurface=function( path ){
	var app=this.app;
	
	function onloadfun(){
		app.DecLoading();
	}

	app.IncLoading();

	var image=loadImage( path,onloadfun );
	if( image ) return new gxtkSurface( image,this );

	app.DecLoading();
	return null;
}

gxtkGraphics.prototype.CreateSurface=function( width,height ){

	var canvas=document.createElement( 'canvas' );
	
	canvas.width=width;
	canvas.height=height;
	canvas.meta_width=width;
	canvas.meta_height=height;
	canvas.complete=true;
	
	var surface=new gxtkSurface( canvas,this );
	
	surface.gc=canvas.getContext( '2d' );
	
	return surface;
}

gxtkGraphics.prototype.SetAlpha=function( alpha ){
	this.alpha=alpha;
	this.gc.globalAlpha=alpha;
}

gxtkGraphics.prototype.SetColor=function( r,g,b ){
	this.r=r;
	this.g=g;
	this.b=b;
	this.white=(r==255 && g==255 && b==255);
	this.color="rgb("+(r|0)+","+(g|0)+","+(b|0)+")";
	this.gc.fillStyle=this.color;
	this.gc.strokeStyle=this.color;
}

gxtkGraphics.prototype.SetBlend=function( blend ){
	switch( blend ){
	case 1:
		this.blend="lighter";
		break;
	default:
		this.blend="source-over";
	}
	this.gc.globalCompositeOperation=this.blend;
}

gxtkGraphics.prototype.SetScissor=function( x,y,w,h ){
	this.scissorX=x;
	this.scissorY=y;
	this.scissorWidth=w;
	this.scissorHeight=h;
	this.clipped=(x!=0 || y!=0 || w!=this.canvas.width || h!=this.canvas.height);
	this.gc.restore();
	this.gc.save();
	if( this.clipped ){
		this.gc.beginPath();
		this.gc.rect( x,y,w,h );
		this.gc.clip();
		this.gc.closePath();
	}
	this.gc.fillStyle=this.color;
	this.gc.strokeStyle=this.color;
	if( this.tformed ) this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
}

gxtkGraphics.prototype.SetMatrix=function( ix,iy,jx,jy,tx,ty ){
	this.ix=ix;this.iy=iy;
	this.jx=jx;this.jy=jy;
	this.tx=tx;this.ty=ty;
	this.gc.setTransform( ix,iy,jx,jy,tx,ty );
	this.tformed=(ix!=1 || iy!=0 || jx!=0 || jy!=1 || tx!=0 || ty!=0);
}

gxtkGraphics.prototype.Cls=function( r,g,b ){
	if( this.tformed ) this.gc.setTransform( 1,0,0,1,0,0 );
	this.gc.fillStyle="rgb("+(r|0)+","+(g|0)+","+(b|0)+")";
	this.gc.globalAlpha=1;
	this.gc.globalCompositeOperation="source-over";
	this.gc.fillRect( 0,0,this.canvas.width,this.canvas.height );
	this.gc.fillStyle=this.color;
	this.gc.globalAlpha=this.alpha;
	this.gc.globalCompositeOperation=this.blend;
	if( this.tformed ) this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
}

gxtkGraphics.prototype.DrawPoint=function( x,y ){
	if( this.tformed ){
		var px=x;
		x=px * this.ix + y * this.jx + this.tx;
		y=px * this.iy + y * this.jy + this.ty;
		this.gc.setTransform( 1,0,0,1,0,0 );
		this.gc.fillRect( x,y,1,1 );
		this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
	}else{
		this.gc.fillRect( x,y,1,1 );
	}
}

gxtkGraphics.prototype.DrawRect=function( x,y,w,h ){
	if( w<0 ){ x+=w;w=-w; }
	if( h<0 ){ y+=h;h=-h; }
	if( w<=0 || h<=0 ) return;
	//
	this.gc.fillRect( x,y,w,h );
}

gxtkGraphics.prototype.DrawLine=function( x1,y1,x2,y2 ){
	if( this.tformed ){
		var x1_t=x1 * this.ix + y1 * this.jx + this.tx;
		var y1_t=x1 * this.iy + y1 * this.jy + this.ty;
		var x2_t=x2 * this.ix + y2 * this.jx + this.tx;
		var y2_t=x2 * this.iy + y2 * this.jy + this.ty;
		this.gc.setTransform( 1,0,0,1,0,0 );
	  	this.gc.beginPath();
	  	this.gc.moveTo( x1_t,y1_t );
	  	this.gc.lineTo( x2_t,y2_t );
	  	this.gc.stroke();
	  	this.gc.closePath();
		this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
	}else{
	  	this.gc.beginPath();
	  	this.gc.moveTo( x1,y1 );
	  	this.gc.lineTo( x2,y2 );
	  	this.gc.stroke();
	  	this.gc.closePath();
	}
}

gxtkGraphics.prototype.DrawOval=function( x,y,w,h ){
	if( w<0 ){ x+=w;w=-w; }
	if( h<0 ){ y+=h;h=-h; }
	if( w<=0 || h<=0 ) return;
	//
  	var w2=w/2,h2=h/2;
	this.gc.save();
	this.gc.translate( x+w2,y+h2 );
	this.gc.scale( w2,h2 );
  	this.gc.beginPath();
	this.gc.arc( 0,0,1,0,Math.PI*2,false );
	this.gc.fill();
  	this.gc.closePath();
	this.gc.restore();
}

gxtkGraphics.prototype.DrawPoly=function( verts ){
	if( verts.length<6 ) return;
	this.gc.beginPath();
	this.gc.moveTo( verts[0],verts[1] );
	for( var i=2;i<verts.length;i+=2 ){
		this.gc.lineTo( verts[i],verts[i+1] );
	}
	this.gc.fill();
	this.gc.closePath();
}

gxtkGraphics.prototype.DrawSurface=function( surface,x,y ){
	if( !surface.image.complete ) return;
	
	if( this.white ){
		this.gc.drawImage( surface.image,x,y );
		return;
	}
	
	this.DrawImageTinted( surface.image,x,y,0,0,surface.swidth,surface.sheight );
}

gxtkGraphics.prototype.DrawSurface2=function( surface,x,y,srcx,srcy,srcw,srch ){
	if( !surface.image.complete ) return;

	if( srcw<0 ){ srcx+=srcw;srcw=-srcw; }
	if( srch<0 ){ srcy+=srch;srch=-srch; }
	if( srcw<=0 || srch<=0 ) return;

	if( this.white ){
		this.gc.drawImage( surface.image,srcx,srcy,srcw,srch,x,y,srcw,srch );
		return;
	}
	
	this.DrawImageTinted( surface.image,x,y,srcx,srcy,srcw,srch  );
}

gxtkGraphics.prototype.DrawImageTinted=function( image,dx,dy,sx,sy,sw,sh ){

	if( !this.tmpCanvas ){
		this.tmpCanvas=document.createElement( "canvas" );
	}

	if( sw>this.tmpCanvas.width || sh>this.tmpCanvas.height ){
		this.tmpCanvas.width=Math.max( sw,this.tmpCanvas.width );
		this.tmpCanvas.height=Math.max( sh,this.tmpCanvas.height );
	}
	
	var tmpGC=this.tmpCanvas.getContext( "2d" );
	tmpGC.globalCompositeOperation="copy";
	
	tmpGC.drawImage( image,sx,sy,sw,sh,0,0,sw,sh );
	
	var imgData=tmpGC.getImageData( 0,0,sw,sh );
	
	var p=imgData.data,sz=sw*sh*4,i;
	
	for( i=0;i<sz;i+=4 ){
		p[i]=p[i]*this.r/255;
		p[i+1]=p[i+1]*this.g/255;
		p[i+2]=p[i+2]*this.b/255;
	}
	
	tmpGC.putImageData( imgData,0,0 );
	
	this.gc.drawImage( this.tmpCanvas,0,0,sw,sh,dx,dy,sw,sh );
}

gxtkGraphics.prototype.ReadPixels=function( pixels,x,y,width,height,offset,pitch ){

	var imgData=this.gc.getImageData( x,y,width,height );
	
	var p=imgData.data,i=0,j=offset,px,py;
	
	for( py=0;py<height;++py ){
		for( px=0;px<width;++px ){
			pixels[j++]=(p[i+3]<<24)|(p[i]<<16)|(p[i+1]<<8)|p[i+2];
			i+=4;
		}
		j+=pitch-width;
	}
}

gxtkGraphics.prototype.WritePixels2=function( surface,pixels,x,y,width,height,offset,pitch ){

	if( !surface.gc ){
		if( !surface.image.complete ) return;
		var canvas=document.createElement( "canvas" );
		canvas.width=surface.swidth;
		canvas.height=surface.sheight;
		surface.gc=canvas.getContext( "2d" );
		surface.gc.globalCompositeOperation="copy";
		surface.gc.drawImage( surface.image,0,0 );
		surface.image=canvas;
	}

	var imgData=surface.gc.createImageData( width,height );

	var p=imgData.data,i=0,j=offset,px,py,argb;
	
	for( py=0;py<height;++py ){
		for( px=0;px<width;++px ){
			argb=pixels[j++];
			p[i]=(argb>>16) & 0xff;
			p[i+1]=(argb>>8) & 0xff;
			p[i+2]=argb & 0xff;
			p[i+3]=(argb>>24) & 0xff;
			i+=4;
		}
		j+=pitch-width;
	}
	
	surface.gc.putImageData( imgData,x,y );
}

//***** gxtkSurface class *****

function gxtkSurface( image,graphics ){
	this.image=image;
	this.graphics=graphics;
	this.swidth=image.meta_width;
	this.sheight=image.meta_height;
}

//***** GXTK API *****

gxtkSurface.prototype.Discard=function(){
	if( this.image ){
		this.image=null;
	}
}

gxtkSurface.prototype.Width=function(){
	return this.swidth;
}

gxtkSurface.prototype.Height=function(){
	return this.sheight;
}

gxtkSurface.prototype.Loaded=function(){
	return this.image.complete;
}

//***** Class gxtkInput *****

function gxtkInput( app ){
	this.app=app;
	this.keyStates=new Array( 512 );
	this.charQueue=new Array( 32 );
	this.charPut=0;
	this.charGet=0;
	this.mouseX=0;
	this.mouseY=0;
	this.joyX=0;
	this.joyY=0;
	this.joyZ=0;
	this.touchIds=new Array( 32 );
	this.touchXs=new Array( 32 );
	this.touchYs=new Array( 32 );
	this.accelX=0;
	this.accelY=0;
	this.accelZ=0;
	
	var i;
	
	for( i=0;i<512;++i ){
		this.keyStates[i]=0;
	}
	
	for( i=0;i<32;++i ){
		this.touchIds[i]=-1;
		this.touchXs[i]=0;
		this.touchYs[i]=0;
	}
}

gxtkInput.prototype.BeginUpdate=function(){
}

gxtkInput.prototype.EndUpdate=function(){
	for( var i=0;i<512;++i ){
		this.keyStates[i]&=0x100;
	}
	this.charGet=0;
	this.charPut=0;
}

gxtkInput.prototype.OnKeyDown=function( key ){
	if( (this.keyStates[key]&0x100)==0 ){
		this.keyStates[key]|=0x100;
		++this.keyStates[key];
		//
		if( key==KEY_LMB ){
			this.keyStates[KEY_TOUCH0]|=0x100;
			++this.keyStates[KEY_TOUCH0];
		}else if( key==KEY_TOUCH0 ){
			this.keyStates[KEY_LMB]|=0x100;
			++this.keyStates[KEY_LMB];
		}
		//
	}
}

gxtkInput.prototype.OnKeyUp=function( key ){
	this.keyStates[key]&=0xff;
	//
	if( key==KEY_LMB ){
		this.keyStates[KEY_TOUCH0]&=0xff;
	}else if( key==KEY_TOUCH0 ){
		this.keyStates[KEY_LMB]&=0xff;
	}
	//
}

gxtkInput.prototype.PutChar=function( chr ){
	if( this.charPut-this.charGet<32 ){
		this.charQueue[this.charPut & 31]=chr;
		this.charPut+=1;
	}
}

gxtkInput.prototype.OnMouseMove=function( x,y ){
	this.mouseX=x;
	this.mouseY=y;
	this.touchXs[0]=x;
	this.touchYs[0]=y;
}

gxtkInput.prototype.OnTouchStart=function( id,x,y ){
	for( var i=0;i<32;++i ){
		if( this.touchIds[i]==-1 ){
			this.touchIds[i]=id;
			this.touchXs[i]=x;
			this.touchYs[i]=y;
			this.OnKeyDown( KEY_TOUCH0+i );
			return;
		} 
	}
}

gxtkInput.prototype.OnTouchMove=function( id,x,y ){
	for( var i=0;i<32;++i ){
		if( this.touchIds[i]==id ){
			this.touchXs[i]=x;
			this.touchYs[i]=y;
			if( i==0 ){
				this.mouseX=x;
				this.mouseY=y;
			}
			return;
		}
	}
}

gxtkInput.prototype.OnTouchEnd=function( id ){
	for( var i=0;i<32;++i ){
		if( this.touchIds[i]==id ){
			this.touchIds[i]=-1;
			this.OnKeyUp( KEY_TOUCH0+i );
			return;
		}
	}
}

gxtkInput.prototype.OnDeviceMotion=function( x,y,z ){
	this.accelX=x;
	this.accelY=y;
	this.accelZ=z;
}

//***** GXTK API *****

gxtkInput.prototype.SetKeyboardEnabled=function( enabled ){
	return 0;
}

gxtkInput.prototype.KeyDown=function( key ){
	if( key>0 && key<512 ){
		return this.keyStates[key] >> 8;
	}
	return 0;
}

gxtkInput.prototype.KeyHit=function( key ){
	if( key>0 && key<512 ){
		return this.keyStates[key] & 0xff;
	}
	return 0;
}

gxtkInput.prototype.GetChar=function(){
	if( this.charPut!=this.charGet ){
		var chr=this.charQueue[this.charGet & 31];
		this.charGet+=1;
		return chr;
	}
	return 0;
}

gxtkInput.prototype.MouseX=function(){
	return this.mouseX;
}

gxtkInput.prototype.MouseY=function(){
	return this.mouseY;
}

gxtkInput.prototype.JoyX=function( index ){
	return this.joyX;
}

gxtkInput.prototype.JoyY=function( index ){
	return this.joyY;
}

gxtkInput.prototype.JoyZ=function( index ){
	return this.joyZ;
}

gxtkInput.prototype.TouchX=function( index ){
	return this.touchXs[index];
}

gxtkInput.prototype.TouchY=function( index ){
	return this.touchYs[index];
}

gxtkInput.prototype.AccelX=function(){
	return this.accelX;
}

gxtkInput.prototype.AccelY=function(){
	return this.accelY;
}

gxtkInput.prototype.AccelZ=function(){
	return this.accelZ;
}


//***** gxtkChannel class *****
function gxtkChannel(){
	this.sample=null;
	this.audio=null;
	this.volume=1;
	this.pan=0;
	this.rate=1;
	this.flags=0;
	this.state=0;
}

//***** gxtkAudio class *****
function gxtkAudio( app ){
	this.app=app;
	this.okay=typeof(Audio)!="undefined";
	this.nextchan=0;
	this.music=null;
	this.channels=new Array(33);
	for( var i=0;i<33;++i ){
		this.channels[i]=new gxtkChannel();
	}
}

gxtkAudio.prototype.OnSuspend=function(){
	var i;
	for( i=0;i<33;++i ){
		var chan=this.channels[i];
		if( chan.state==1 ) chan.audio.pause();
	}
}

gxtkAudio.prototype.OnResume=function(){
	var i;
	for( i=0;i<33;++i ){
		var chan=this.channels[i];
		if( chan.state==1 ) chan.audio.play();
	}
}

gxtkAudio.prototype.LoadSample=function( path ){
	var audio=loadAudio( path );
	if( audio ) return new gxtkSample( audio );
	return null;
}

gxtkAudio.prototype.PlaySample=function( sample,channel,flags ){
	if( !this.okay ) return;

	var chan=this.channels[channel];

	if( chan.state!=0 ){
		chan.audio.pause();
		chan.state=0;
	}
	
	for( var i=0;i<33;++i ){
		var chan2=this.channels[i];
		if( chan2.state==1 && chan2.audio.ended && !chan2.audio.loop ) chan.state=0;
		if( chan2.state==0 && chan2.sample ){
			chan2.sample.FreeAudio( chan2.audio );
			chan2.sample=null;
			chan2.audio=null;
		}
	}

	var audio=sample.AllocAudio();
	if( !audio ) return;
	
	audio.loop=(flags&1)!=0;
	audio.volume=chan.volume;
	audio.play();

	chan.sample=sample;
	chan.audio=audio;
	chan.flags=flags;
	chan.state=1;
}

gxtkAudio.prototype.StopChannel=function( channel ){
	var chan=this.channels[channel];
	
	if( chan.state!=0 ){
		chan.audio.pause();
		chan.state=0;
	}
}

gxtkAudio.prototype.PauseChannel=function( channel ){
	var chan=this.channels[channel];
	
	if( chan.state==1 ){
		if( chan.audio.ended && !chan.audio.loop ){
			chan.state=0;
		}else{
			chan.audio.pause();
			chan.state=2;
		}
	}
}

gxtkAudio.prototype.ResumeChannel=function( channel ){
	var chan=this.channels[channel];
	
	if( chan.state==2 ){
		chan.audio.play();
		chan.state=1;
	}
}

gxtkAudio.prototype.ChannelState=function( channel ){
	var chan=this.channels[channel];
	if( chan.state==1 && chan.audio.ended && !chan.audio.loop ) chan.state=0;
	return chan.state;
}

gxtkAudio.prototype.SetVolume=function( channel,volume ){
	var chan=this.channels[channel];
	if( chan.state!=0 ) chan.audio.volume=volume;
	chan.volume=volume;
}

gxtkAudio.prototype.SetPan=function( channel,pan ){
	var chan=this.channels[channel];
	chan.pan=pan;
}

gxtkAudio.prototype.SetRate=function( channel,rate ){
	var chan=this.channels[channel];
	chan.rate=rate;
}

gxtkAudio.prototype.PlayMusic=function( path,flags ){
	this.StopMusic();
	
	this.music=this.LoadSample( path );
	if( !this.music ) return;
	
	this.PlaySample( this.music,32,flags );
}

gxtkAudio.prototype.StopMusic=function(){
	this.StopChannel( 32 );

	if( this.music ){
		this.music.Discard();
		this.music=null;
	}
}

gxtkAudio.prototype.PauseMusic=function(){
	this.PauseChannel( 32 );
}

gxtkAudio.prototype.ResumeMusic=function(){
	this.ResumeChannel( 32 );
}

gxtkAudio.prototype.MusicState=function(){
	return this.ChannelState( 32 );
}

gxtkAudio.prototype.SetMusicVolume=function( volume ){
	this.SetVolume( 32,volume );
}

//***** gxtkSample class *****

function gxtkSample( audio ){
	this.audio=audio;
	this.free=new Array();
	this.insts=new Array();
}

gxtkSample.prototype.Discard=function(){
}

gxtkSample.prototype.FreeAudio=function( audio ){
	this.free.push( audio );
}

gxtkSample.prototype.AllocAudio=function(){
	var audio;
	while( this.free.length ){
		audio=this.free.pop();
		try{
			audio.currentTime=0;
			return audio;
		}catch( ex ){
			print( "AUDIO ERROR1!" );
		}
	}
	
	//Max out?
	if( this.insts.length==8 ) return null;
	
	audio=new Audio( this.audio.src );
	
	//yucky loop handler for firefox!
	//
	audio.addEventListener( 'ended',function(){
		if( this.loop ){
			try{
				this.currentTime=0;
				this.play();
			}catch( ex ){
				print( "AUDIO ERROR2!" );
			}
		}
	},false );

	this.insts.push( audio );
	return audio;
}
function bb_app_App(){
	Object.call(this);
}
function bb_app_App_new(){
	bb_app_device=bb_app_AppDevice_new.call(new bb_app_AppDevice,this);
	return this;
}
bb_app_App.prototype.m_OnCreate=function(){
	return 0;
}
bb_app_App.prototype.m_OnUpdate=function(){
	return 0;
}
bb_app_App.prototype.m_OnSuspend=function(){
	return 0;
}
bb_app_App.prototype.m_OnResume=function(){
	return 0;
}
bb_app_App.prototype.m_OnRender=function(){
	return 0;
}
bb_app_App.prototype.m_OnLoading=function(){
	return 0;
}
function bb_bpb_BPB(){
	bb_app_App.call(this);
}
bb_bpb_BPB.prototype=extend_class(bb_app_App);
function bb_bpb_BPB_new(){
	bb_app_App_new.call(this);
	return this;
}
var bb_bpb_BPB_Z;
var bb_bpb_BPB_twi;
var bb_bpb_BPB_unicorn;
var bb_bpb_BPB_pegasus;
var bb_bpb_BPB_earth;
var bb_bpb_BPB_explode;
var bb_bpb_BPB_mask;
var bb_bpb_BPB_mainscreen;
var bb_bpb_BPB_instructions;
var bb_bpb_BPB_commands;
var bb_bpb_BPB_gameover;
var bb_bpb_BPB_gametype;
var bb_bpb_BPB_gametick;
var bb_bpb_BPB_player;
bb_bpb_BPB.prototype.m_newgame=function(){
	bb_bpb_ball_flush();
	bb_bpb_platform_flush();
	bb_bpb_ball_limit2=bb_bpb_platform_new.call(new bb_bpb_platform,320.0,240.0,500.0);
	bb_bpb_platform_new.call(new bb_bpb_platform,320.0,240.0,300.0);
	bb_bpb_ball_limit1=bb_bpb_platform_new.call(new bb_bpb_platform,320.0,240.0,100.0);
	bb_bpb_BPB_player=bb_bpb_ball_new.call(new bb_bpb_ball,320.0,240.0,0.0,20.0,2.0,0.2,0);
	bb_bpb_BPB_gametick=0;
	return 0;
}
bb_bpb_BPB.prototype.m_OnCreate=function(){
	bb_bpb_BPB_Z=bb_graphics_LoadImage("Z1007.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_twi=bb_graphics_LoadImage("main.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_unicorn=bb_graphics_LoadImage("unicorn.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_pegasus=bb_graphics_LoadImage("pegasus.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_earth=bb_graphics_LoadImage("normal.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_explode=bb_graphics_LoadImage("explode.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_mask=bb_graphics_LoadImage("main.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_mainscreen=bb_graphics_LoadImage("mainscreen.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_instructions=bb_graphics_LoadImage("instructions.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_commands=bb_graphics_LoadImage("buttons.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_button_init();
	bb_bpb_BPB_gameover=bb_graphics_LoadImage("gameover.png",1,bb_graphics_Image_DefaultFlags);
	bb_bpb_BPB_gametype=[bb_bpb_BPB_twi,bb_bpb_BPB_unicorn,bb_bpb_BPB_pegasus,bb_bpb_BPB_earth];
	bb_bpb_BPB_gametick=0;
	bb_app_SetUpdateRate(50);
	this.m_newgame();
	bb_bpb_ball_autoplay=1;
	return 0;
}
var bb_bpb_BPB_gamestatus;
bb_bpb_BPB.prototype.m_updategame=function(t_mx,t_my,t_md){
	bb_bpb_BPB_gametick=bb_bpb_BPB_gametick+1;
	bb_bpb_ball_updateall(t_mx,t_my,t_md,0);
	bb_bpb_ball_moveall();
	var t_delay=48;
	if(bb_bpb_BPB_gametick>1500){
		t_delay=40;
	}
	if(bb_bpb_BPB_gametick>3000){
		t_delay=32;
	}
	if(bb_bpb_BPB_gametick>4500){
		t_delay=24;
	}
	if(bb_bpb_BPB_gametick>6000){
		t_delay=16;
	}
	if(bb_bpb_BPB_gametick>7500){
		t_delay=8;
	}
	if(bb_bpb_BPB_gametick % t_delay==0){
		bb_bpb_ball_generate();
	}
	return 0;
}
bb_bpb_BPB.prototype.m_OnUpdate=function(){
	var t_mx=((bb_input_MouseX())|0);
	var t_my=((bb_input_MouseY())|0);
	var t_md=bb_input_MouseDown(0);
	var t_mc=bb_input_MouseHit(0);
	if(bb_bpb_BPB_gamestatus==0){
		if((bb_bpb_button_updatebutton(1,0,420,t_mx,t_my,t_mc))!=0){
			bb_bpb_BPB_gamestatus=1;
		}
		if((bb_bpb_button_updatebutton(0,340,420,t_mx,t_my,t_mc))!=0){
			bb_bpb_BPB_gamestatus=2;
			bb_bpb_ball_autoplay=0;
			this.m_newgame();
		}
	}else{
		if(bb_bpb_BPB_gamestatus==1){
			if((bb_bpb_button_updatebutton(2,0,420,t_mx,t_my,t_mc))!=0){
				bb_bpb_BPB_gamestatus=0;
			}
		}
	}
	if((bb_bpb_ball_autoplay)!=0){
		if(bb_bpb_BPB_player.f_status>50){
			this.m_newgame();
		}else{
			this.m_updategame(t_mx,t_my,t_md);
		}
	}else{
		if((bb_input_KeyHit(13))!=0){
			this.m_newgame();
		}
		if((bb_input_KeyDown(32))!=0){
			bb_bpb_ball_main.f_requestshield=1;
		}else{
			bb_bpb_ball_main.f_requestshield=0;
		}
		if(bb_bpb_BPB_player.f_status<99){
			this.m_updategame(t_mx,t_my,t_md);
		}else{
			if((bb_bpb_button_updatebutton(3,170,380,t_mx,t_my,t_mc))!=0){
				this.m_newgame();
			}else{
				if((bb_input_KeyHit(27))!=0){
					this.m_newgame();
					bb_bpb_BPB_gamestatus=0;
					bb_bpb_ball_autoplay=1;
				}
			}
		}
	}
	return 0;
}
var bb_bpb_BPB_camerax;
var bb_bpb_BPB_cameray;
bb_bpb_BPB.prototype.m_OnRender=function(){
	bb_graphics_Cls(128.0,0.0,0.0);
	bb_bpb_BPB_camerax=bb_bpb_BPB_player.f_x-320.0;
	bb_bpb_BPB_cameray=bb_bpb_BPB_player.f_y-240.0;
	bb_bpb_platform_renderall(((bb_bpb_BPB_camerax)|0),((bb_bpb_BPB_cameray)|0));
	bb_bpb_ball_renderall(bb_bpb_BPB_camerax,bb_bpb_BPB_cameray);
	if(bb_bpb_BPB_player.f_status==99){
		bb_graphics_SetAlpha(0.75);
		bb_graphics_SetColor(0.0,0.0,0.0);
		bb_graphics_DrawRect(0.0,0.0,640.0,480.0);
		bb_graphics_SetAlpha(1.0);
		bb_graphics_SetColor(255.0,255.0,255.0);
		bb_graphics_SetColor(0.0,0.0,0.0);
		bb_graphics_DrawImage(bb_bpb_BPB_gameover,10.0,10.0,0);
		bb_graphics_SetColor(255.0,255.0,255.0);
		bb_graphics_DrawImage(bb_bpb_BPB_gameover,0.0,0.0,0);
		bb_graphics_DrawText("You lasted: "+bb_bpb_timing(bb_bpb_BPB_gametick),150.0,330.0,0.0,0.0);
		bb_graphics_DrawText("And you have sent "+String(bb_bpb_ball_kills)+" ponies back to Equestria.",150.0,350.0,0.0,0.0);
		bb_graphics_DrawText("Click retry or hit ENTER to try again",200.0,430.0,0.0,0.0);
		bb_graphics_DrawText("Press Escape to return to main menu",200.0,450.0,0.0,0.0);
		bb_bpb_button_drawbutton(3,170,380);
	}else{
		if(bb_bpb_ball_autoplay==0){
			bb_graphics_DrawText("Survival Time : "+bb_bpb_timing(bb_bpb_BPB_gametick),10.0,10.0,0.0,0.0);
			bb_graphics_DrawText("Ponies released : "+String(bb_bpb_ball_kills),10.0,30.0,0.0,0.0);
			bb_bpb_drawbox(10,50,251,13);
			if(bb_bpb_ball_main.f_shield>0){
				bb_graphics_SetColor(255.0,0.0,0.0);
				bb_graphics_DrawRect(11.0,52.0,(bb_bpb_ball_main.f_shield),10.0);
				bb_graphics_SetColor(255.0,255.0,255.0);
			}
		}else{
			if(bb_bpb_BPB_gamestatus==0){
				bb_graphics_SetColor(0.0,0.0,0.0);
				bb_graphics_DrawImage(bb_bpb_BPB_mainscreen,10.0,10.0,0);
				bb_graphics_SetColor(255.0,255.0,255.0);
				bb_graphics_DrawImage(bb_bpb_BPB_mainscreen,0.0,0.0,0);
				bb_bpb_button_drawbutton(1,0,420);
				bb_bpb_button_drawbutton(0,340,420);
			}
			if(bb_bpb_BPB_gamestatus==1){
				bb_graphics_SetAlpha(0.75);
				bb_graphics_SetColor(0.0,0.0,0.0);
				bb_graphics_DrawRect(0.0,0.0,640.0,480.0);
				bb_graphics_SetAlpha(1.0);
				bb_graphics_SetColor(255.0,255.0,255.0);
				bb_graphics_DrawImage(bb_bpb_BPB_instructions,0.0,0.0,0);
				bb_bpb_button_drawbutton(2,0,420);
			}
		}
	}
	return 0;
}
function bb_app_AppDevice(){
	gxtkApp.call(this);
	this.f_app=null;
	this.f_updateRate=0;
}
bb_app_AppDevice.prototype=extend_class(gxtkApp);
function bb_app_AppDevice_new(t_app){
	this.f_app=t_app;
	bb_graphics_SetGraphicsContext(bb_graphics_GraphicsContext_new.call(new bb_graphics_GraphicsContext,this.GraphicsDevice()));
	bb_input_SetInputDevice(this.InputDevice());
	bb_audio_SetAudioDevice(this.AudioDevice());
	return this;
}
function bb_app_AppDevice_new2(){
	return this;
}
bb_app_AppDevice.prototype.OnCreate=function(){
	bb_graphics_SetFont(null,32);
	return this.f_app.m_OnCreate();
}
bb_app_AppDevice.prototype.OnUpdate=function(){
	return this.f_app.m_OnUpdate();
}
bb_app_AppDevice.prototype.OnSuspend=function(){
	return this.f_app.m_OnSuspend();
}
bb_app_AppDevice.prototype.OnResume=function(){
	return this.f_app.m_OnResume();
}
bb_app_AppDevice.prototype.OnRender=function(){
	bb_graphics_BeginRender();
	var t_r=this.f_app.m_OnRender();
	bb_graphics_EndRender();
	return t_r;
}
bb_app_AppDevice.prototype.OnLoading=function(){
	bb_graphics_BeginRender();
	var t_r=this.f_app.m_OnLoading();
	bb_graphics_EndRender();
	return t_r;
}
bb_app_AppDevice.prototype.SetUpdateRate=function(t_hertz){
	gxtkApp.prototype.SetUpdateRate.call(this,t_hertz);
	this.f_updateRate=t_hertz;
	return 0;
}
function bb_graphics_GraphicsContext(){
	Object.call(this);
	this.f_device=null;
	this.f_defaultFont=null;
	this.f_font=null;
	this.f_firstChar=0;
	this.f_matrixSp=0;
	this.f_ix=1.0;
	this.f_iy=.0;
	this.f_jx=.0;
	this.f_jy=1.0;
	this.f_tx=.0;
	this.f_ty=.0;
	this.f_tformed=0;
	this.f_matDirty=0;
	this.f_color_r=.0;
	this.f_color_g=.0;
	this.f_color_b=.0;
	this.f_alpha=.0;
	this.f_blend=0;
	this.f_scissor_x=.0;
	this.f_scissor_y=.0;
	this.f_scissor_width=.0;
	this.f_scissor_height=.0;
	this.f_matrixStack=new_number_array(192);
}
function bb_graphics_GraphicsContext_new(t_device){
	this.f_device=t_device;
	return this;
}
function bb_graphics_GraphicsContext_new2(){
	return this;
}
var bb_graphics_context;
function bb_graphics_SetGraphicsContext(t_gc){
	bb_graphics_context=t_gc;
	return 0;
}
var bb_input_device;
function bb_input_SetInputDevice(t_dev){
	bb_input_device=t_dev;
	return 0;
}
var bb_audio_device;
function bb_audio_SetAudioDevice(t_dev){
	bb_audio_device=t_dev;
	return 0;
}
var bb_app_device;
function bbMain(){
	bb_bpb_BPB_new.call(new bb_bpb_BPB);
	return 0;
}
function bb_graphics_Image(){
	Object.call(this);
	this.f_surface=null;
	this.f_width=0;
	this.f_height=0;
	this.f_frames=[];
	this.f_flags=0;
	this.f_tx=.0;
	this.f_ty=.0;
	this.f_source=null;
}
var bb_graphics_Image_DefaultFlags;
function bb_graphics_Image_new(){
	return this;
}
bb_graphics_Image.prototype.m_SetHandle=function(t_tx,t_ty){
	this.f_tx=t_tx;
	this.f_ty=t_ty;
	this.f_flags=this.f_flags&-2;
	return 0;
}
bb_graphics_Image.prototype.m_ApplyFlags=function(t_iflags){
	this.f_flags=t_iflags;
	if((this.f_flags&2)!=0){
		var t_=this.f_frames;
		var t_2=0;
		while(t_2<t_.length){
			var t_f=t_[t_2];
			t_2=t_2+1;
			t_f.f_x+=1;
		}
		this.f_width-=2;
	}
	if((this.f_flags&4)!=0){
		var t_3=this.f_frames;
		var t_4=0;
		while(t_4<t_3.length){
			var t_f2=t_3[t_4];
			t_4=t_4+1;
			t_f2.f_y+=1;
		}
		this.f_height-=2;
	}
	if((this.f_flags&1)!=0){
		this.m_SetHandle((this.f_width)/2.0,(this.f_height)/2.0);
	}
	if(this.f_frames.length==1 && this.f_frames[0].f_x==0 && this.f_frames[0].f_y==0 && this.f_width==this.f_surface.Width() && this.f_height==this.f_surface.Height()){
		this.f_flags|=65536;
	}
	return 0;
}
bb_graphics_Image.prototype.m_Load=function(t_path,t_nframes,t_iflags){
	this.f_surface=bb_graphics_context.f_device.LoadSurface(t_path);
	if(!((this.f_surface)!=null)){
		return null;
	}
	this.f_width=((this.f_surface.Width()/t_nframes)|0);
	this.f_height=this.f_surface.Height();
	this.f_frames=new_object_array(t_nframes);
	for(var t_i=0;t_i<t_nframes;t_i=t_i+1){
		this.f_frames[t_i]=bb_graphics_Frame_new.call(new bb_graphics_Frame,t_i*this.f_width,0);
	}
	this.m_ApplyFlags(t_iflags);
	return this;
}
bb_graphics_Image.prototype.m_Grab=function(t_x,t_y,t_iwidth,t_iheight,t_nframes,t_iflags,t_source){
	this.f_source=t_source;
	this.f_surface=t_source.f_surface;
	this.f_width=t_iwidth;
	this.f_height=t_iheight;
	this.f_frames=new_object_array(t_nframes);
	var t_ix=t_x;
	var t_iy=t_y;
	for(var t_i=0;t_i<t_nframes;t_i=t_i+1){
		if(t_ix+this.f_width>t_source.f_width){
			t_ix=0;
			t_iy+=this.f_height;
		}
		if(t_ix+this.f_width>t_source.f_width || t_iy+this.f_height>t_source.f_height){
			error("Image frame outside surface");
		}
		this.f_frames[t_i]=bb_graphics_Frame_new.call(new bb_graphics_Frame,t_ix+t_source.f_frames[0].f_x,t_iy+t_source.f_frames[0].f_y);
		t_ix+=this.f_width;
	}
	this.m_ApplyFlags(t_iflags);
	return this;
}
bb_graphics_Image.prototype.m_GrabImage=function(t_x,t_y,t_width,t_height,t_frames,t_flags){
	if(this.f_frames.length!=1){
		return null;
	}
	return (bb_graphics_Image_new.call(new bb_graphics_Image)).m_Grab(t_x,t_y,t_width,t_height,t_frames,t_flags,this);
}
bb_graphics_Image.prototype.m_Width=function(){
	return this.f_width;
}
bb_graphics_Image.prototype.m_Height=function(){
	return this.f_height;
}
bb_graphics_Image.prototype.m_Frames=function(){
	return this.f_frames.length;
}
function bb_graphics_Frame(){
	Object.call(this);
	this.f_x=0;
	this.f_y=0;
}
function bb_graphics_Frame_new(t_x,t_y){
	this.f_x=t_x;
	this.f_y=t_y;
	return this;
}
function bb_graphics_Frame_new2(){
	return this;
}
function bb_graphics_LoadImage(t_path,t_frameCount,t_flags){
	return (bb_graphics_Image_new.call(new bb_graphics_Image)).m_Load(t_path,t_frameCount,t_flags);
}
function bb_graphics_LoadImage2(t_path,t_frameWidth,t_frameHeight,t_frameCount,t_flags){
	var t_atlas=(bb_graphics_Image_new.call(new bb_graphics_Image)).m_Load(t_path,1,0);
	if((t_atlas)!=null){
		return t_atlas.m_GrabImage(0,0,t_frameWidth,t_frameHeight,t_frameCount,t_flags);
	}
	return null;
}
function bb_graphics_SetFont(t_font,t_firstChar){
	if(!((t_font)!=null)){
		if(!((bb_graphics_context.f_defaultFont)!=null)){
			bb_graphics_context.f_defaultFont=bb_graphics_LoadImage("mojo_font.png",96,2);
		}
		t_font=bb_graphics_context.f_defaultFont;
		t_firstChar=32;
	}
	bb_graphics_context.f_font=t_font;
	bb_graphics_context.f_firstChar=t_firstChar;
	return 0;
}
var bb_graphics_renderDevice;
function bb_graphics_SetMatrix(t_ix,t_iy,t_jx,t_jy,t_tx,t_ty){
	bb_graphics_context.f_ix=t_ix;
	bb_graphics_context.f_iy=t_iy;
	bb_graphics_context.f_jx=t_jx;
	bb_graphics_context.f_jy=t_jy;
	bb_graphics_context.f_tx=t_tx;
	bb_graphics_context.f_ty=t_ty;
	bb_graphics_context.f_tformed=((t_ix!=1.0 || t_iy!=0.0 || t_jx!=0.0 || t_jy!=1.0 || t_tx!=0.0 || t_ty!=0.0)?1:0);
	bb_graphics_context.f_matDirty=1;
	return 0;
}
function bb_graphics_SetMatrix2(t_m){
	bb_graphics_SetMatrix(t_m[0],t_m[1],t_m[2],t_m[3],t_m[4],t_m[5]);
	return 0;
}
function bb_graphics_SetColor(t_r,t_g,t_b){
	bb_graphics_context.f_color_r=t_r;
	bb_graphics_context.f_color_g=t_g;
	bb_graphics_context.f_color_b=t_b;
	bb_graphics_context.f_device.SetColor(t_r,t_g,t_b);
	return 0;
}
function bb_graphics_SetAlpha(t_alpha){
	bb_graphics_context.f_alpha=t_alpha;
	bb_graphics_context.f_device.SetAlpha(t_alpha);
	return 0;
}
function bb_graphics_SetBlend(t_blend){
	bb_graphics_context.f_blend=t_blend;
	bb_graphics_context.f_device.SetBlend(t_blend);
	return 0;
}
function bb_graphics_DeviceWidth(){
	return bb_graphics_context.f_device.Width();
}
function bb_graphics_DeviceHeight(){
	return bb_graphics_context.f_device.Height();
}
function bb_graphics_SetScissor(t_x,t_y,t_width,t_height){
	bb_graphics_context.f_scissor_x=t_x;
	bb_graphics_context.f_scissor_y=t_y;
	bb_graphics_context.f_scissor_width=t_width;
	bb_graphics_context.f_scissor_height=t_height;
	bb_graphics_context.f_device.SetScissor(((t_x)|0),((t_y)|0),((t_width)|0),((t_height)|0));
	return 0;
}
function bb_graphics_BeginRender(){
	if(!((bb_graphics_context.f_device.Mode())!=0)){
		return 0;
	}
	bb_graphics_renderDevice=bb_graphics_context.f_device;
	bb_graphics_context.f_matrixSp=0;
	bb_graphics_SetMatrix(1.0,0.0,0.0,1.0,0.0,0.0);
	bb_graphics_SetColor(255.0,255.0,255.0);
	bb_graphics_SetAlpha(1.0);
	bb_graphics_SetBlend(0);
	bb_graphics_SetScissor(0.0,0.0,(bb_graphics_DeviceWidth()),(bb_graphics_DeviceHeight()));
	return 0;
}
function bb_graphics_EndRender(){
	bb_graphics_renderDevice=null;
	return 0;
}
function bb_bpb_button(){
	Object.call(this);
	this.f_id=0;
	this.f_img=null;
	this.f_hover=0;
}
var bb_bpb_button_list;
function bb_bpb_button_new(){
	return this;
}
var bb_bpb_button_all;
function bb_bpb_button_init(){
	bb_bpb_button_list=bb_bpb_BPB_commands;
	var t_i=0;
	for(t_i=0;t_i<=3;t_i=t_i+1){
		bb_bpb_button_all[t_i]=bb_bpb_button_new.call(new bb_bpb_button);
		bb_bpb_button_all[t_i].f_id=t_i;
		bb_bpb_button_all[t_i].f_img=bb_bpb_button_list.m_GrabImage(50,5+50*t_i,300,45,1,bb_graphics_Image_DefaultFlags);
	}
	return 0;
}
var bb_bpb_button_width;
var bb_bpb_button_height;
bb_bpb_button.prototype.m_update=function(t_x,t_y,t_mx,t_my,t_mc){
	this.f_hover=0;
	if(t_x<t_mx && t_mx<t_x+bb_bpb_button_width && t_y<t_my && t_my<t_y+bb_bpb_button_height){
		this.f_hover=1;
	}
	if(((t_mc)!=0) && ((this.f_hover)!=0)){
		return 1;
	}
	return 0;
}
function bb_bpb_button_updatebutton(t_i,t_x,t_y,t_mx,t_my,t_mc){
	return bb_bpb_button_all[t_i].m_update(t_x,t_y,t_mx,t_my,t_mc);
}
bb_bpb_button.prototype.m_draw=function(t_x,t_y){
	if((this.f_hover)!=0){
		bb_graphics_SetColor(255.0,0.0,0.0);
	}else{
		bb_graphics_SetColor(255.0,255.0,255.0);
	}
	bb_graphics_DrawImage(this.f_img,(t_x),(t_y),0);
	bb_graphics_SetColor(255.0,255.0,255.0);
	return 0;
}
function bb_bpb_button_drawbutton(t_i,t_x,t_y){
	bb_bpb_button_all[t_i].m_draw(t_x,t_y);
	return 0;
}
function bb_app_SetUpdateRate(t_hertz){
	return bb_app_device.SetUpdateRate(t_hertz);
}
function bb_bpb_ball(){
	Object.call(this);
	this.f_x=.0;
	this.f_y=.0;
	this.f_angle=.0;
	this.f_size=.0;
	this.f_kind=0;
	this.f_mass=.0;
	this.f_speed=.0;
	this.f_status=0;
	this.f_dx=.0;
	this.f_dy=.0;
	this.f_shielded=0;
	this.f_shield=250;
	this.f_requestshield=0;
}
var bb_bpb_ball_main;
var bb_bpb_ball_limit1;
var bb_bpb_ball_limit2;
var bb_bpb_ball_kills;
var bb_bpb_ball_count;
var bb_bpb_ball_all;
function bb_bpb_ball_flush(){
	bb_bpb_ball_main=null;
	bb_bpb_ball_limit1=null;
	bb_bpb_ball_limit2=null;
	bb_bpb_ball_kills=0;
	var t_i=0;
	for(t_i=0;t_i<=bb_bpb_ball_count-1;t_i=t_i+1){
		bb_bpb_ball_all[t_i]=null;
	}
	bb_bpb_ball_count=0;
	return 0;
}
function bb_bpb_ball_new(t_px,t_py,t_a,t_s,t_m,t_sp,t_k){
	this.f_x=t_px;
	this.f_y=t_py;
	this.f_angle=t_a;
	this.f_size=t_s;
	this.f_kind=t_k;
	this.f_mass=t_m;
	this.f_speed=t_sp;
	bb_bpb_ball_all[bb_bpb_ball_count]=this;
	bb_bpb_ball_count=bb_bpb_ball_count+1;
	this.f_status=0;
	if(this.f_kind==0){
		bb_bpb_ball_main=this;
	}
	return this;
}
function bb_bpb_ball_new2(){
	return this;
}
var bb_bpb_ball_autoplay;
bb_bpb_ball.prototype.m_outofboundary=function(){
	var t_distx=this.f_x-bb_bpb_ball_limit2.f_x;
	var t_disty=this.f_y-bb_bpb_ball_limit2.f_y;
	var t_maxsize=bb_bpb_ball_limit2.f_size-this.f_size;
	if(t_distx*t_distx+t_disty*t_disty>t_maxsize*t_maxsize){
		return 1;
	}
	return 0;
}
bb_bpb_ball.prototype.m_trust=function(){
	if(this.f_status!=50){
		return 0;
	}
	var t_addx=Math.cos((this.f_angle)*D2R)*this.f_speed;
	var t_addy=Math.sin((this.f_angle)*D2R)*this.f_speed;
	this.f_dx+=t_addx;
	this.f_dy+=t_addy;
	return 0;
}
bb_bpb_ball.prototype.m_update2=function(t_mx,t_my,t_md,t_md2){
	if(this.f_status!=50 || ((this.m_outofboundary())!=0)){
		this.f_status+=1;
	}
	if((bb_bpb_ball_autoplay)!=0){
		this.f_angle=(Math.atan2(bb_bpb_ball_limit2.f_y+Math.sin((bb_bpb_BPB_gametick)*D2R)*100.0-this.f_y,bb_bpb_ball_limit2.f_x+Math.cos((bb_bpb_BPB_gametick)*D2R)*100.0-this.f_x)*R2D);
		this.m_trust();
	}else{
		this.f_shielded=0;
		if(this.f_shield>0 && ((this.f_requestshield)!=0) && this.f_status==50){
			this.f_shielded=1;
		}
		if(this.f_shielded==1){
			this.f_shield=this.f_shield-1;
		}
		this.f_angle=(Math.atan2((t_my-240),(t_mx-320))*R2D);
		if((t_md)!=0){
			this.m_trust();
		}
	}
	return 0;
}
bb_bpb_ball.prototype.m_updateai=function(){
	if(this.f_status!=50 || ((this.m_outofboundary())!=0)){
		this.f_status+=1;
	}
	if(this.f_status==51){
		bb_bpb_ball_kills+=1;
	}
	this.f_requestshield=0;
	if(this.f_shield>0 && this.f_kind==1){
		this.f_requestshield=1;
	}
	this.f_shielded=0;
	if(this.f_shield>0 && ((this.f_requestshield)!=0) && this.f_status==50){
		this.f_shielded=1;
	}
	if(this.f_shielded==1){
		this.f_shield=this.f_shield-1;
	}
	this.f_angle=(Math.atan2(bb_bpb_ball_main.f_y-this.f_y,bb_bpb_ball_main.f_x-this.f_x)*R2D);
	this.m_trust();
	return 0;
}
function bb_bpb_ball_updateall(t_mx,t_my,t_md,t_md2){
	var t_i=0;
	for(t_i=0;t_i<=bb_bpb_ball_count-1;t_i=t_i+1){
		if(bb_bpb_ball_all[t_i].f_status>=100){
			continue;
		}
		if(bb_bpb_ball_all[t_i].f_kind==0){
			bb_bpb_ball_all[t_i].m_update2(t_mx,t_my,t_md,t_md2);
		}else{
			bb_bpb_ball_all[t_i].m_updateai();
		}
	}
	return 0;
}
bb_bpb_ball.prototype.m_move=function(){
	if(this.f_status<50){
		return 0;
	}
	this.f_x=this.f_x+this.f_dx;
	this.f_y=this.f_y+this.f_dy;
	this.f_dx=0.98*this.f_dx;
	this.f_dy=0.98*this.f_dy;
	return 0;
}
bb_bpb_ball.prototype.m_colliding=function(t_b){
	if(t_b==this){
		return 0;
	}
	if(t_b.f_status!=50){
		return 0;
	}
	var t_minimum=this.f_size+t_b.f_size;
	var t_distx=this.f_x-t_b.f_x;
	var t_disty=this.f_y-t_b.f_y;
	var t_sq=t_minimum*t_minimum;
	var t_dist=t_distx*t_distx+t_disty*t_disty;
	if(t_dist<=t_sq){
		return 1;
	}
	return 0;
}
bb_bpb_ball.prototype.m_bounce=function(t_addx,t_addy){
	if((this.f_shielded)!=0){
		return 0;
	}
	this.f_dx+=t_addx;
	this.f_dy+=t_addy;
	return 0;
}
bb_bpb_ball.prototype.m_collide=function(){
	if(this.f_status!=50){
		return 0;
	}
	var t_i=0;
	for(t_i=0;t_i<=bb_bpb_ball_count-1;t_i=t_i+1){
		var t_b=bb_bpb_ball_all[t_i];
		if((this.m_colliding(t_b))!=0){
			var t_normal=(Math.atan2(t_b.f_y-this.f_y,t_b.f_x-this.f_x)*R2D);
			var t_distx=this.f_x-t_b.f_x;
			var t_disty=this.f_y-t_b.f_y;
			var t_dist=Math.sqrt(t_distx*t_distx+t_disty*t_disty);
			var t_cdist=this.f_size+t_b.f_size;
			var t_mdist1=(t_cdist-t_dist)*(t_b.f_mass/(this.f_mass+t_b.f_mass));
			var t_mdist2=(t_cdist-t_dist)*(this.f_mass/(this.f_mass+t_b.f_mass));
			this.f_x+=t_mdist1*Math.cos((t_normal+180.0)*D2R);
			this.f_y+=t_mdist1*Math.sin((t_normal+180.0)*D2R);
			t_b.f_x+=t_mdist2*Math.cos((t_normal)*D2R);
			t_b.f_y+=t_mdist2*Math.sin((t_normal)*D2R);
			var t_nx=Math.cos((t_normal)*D2R);
			var t_ny=Math.sin((t_normal)*D2R);
			var t_a1=this.f_dx*t_nx+this.f_dy*t_ny;
			var t_a2=t_b.f_dx*t_nx+t_b.f_dy*t_ny;
			var t_opt=2.0*(t_a1-t_a2)/(t_b.f_mass+this.f_mass);
			this.m_bounce(-t_opt*t_nx*t_b.f_mass*1.2,-t_opt*t_ny*t_b.f_mass*1.2);
			t_b.m_bounce(t_opt*t_nx*t_b.f_mass*1.2,t_opt*t_ny*t_b.f_mass*1.2);
		}
	}
	return 0;
}
function bb_bpb_ball_moveall(){
	var t_i=0;
	for(t_i=0;t_i<=bb_bpb_ball_count-1;t_i=t_i+1){
		if(bb_bpb_ball_all[t_i].f_status>=100){
			continue;
		}
		bb_bpb_ball_all[t_i].m_move();
		bb_bpb_ball_all[t_i].m_collide();
	}
	return 0;
}
function bb_bpb_ball_generate(){
	var t_angle=bb_random_Rnd3(360.0);
	var t_specy=((bb_random_Rnd3(50.0))|0) % 3;
	var t_distance=bb_random_Rnd3(bb_bpb_ball_limit2.f_size-bb_bpb_ball_limit1.f_size)+bb_bpb_ball_limit1.f_size;
	var t_posx=Math.cos((t_angle)*D2R)*t_distance+bb_bpb_ball_limit2.f_x;
	var t_posy=Math.sin((t_angle)*D2R)*t_distance+bb_bpb_ball_limit2.f_y;
	var t_size=bb_random_Rnd3(20.0)+10.0;
	var t_mass=t_size/10.0;
	var t_speed=bb_random_Rnd3(0.3)+0.1;
	if(t_specy==1){
		t_mass=t_mass*0.5;
		t_speed=t_speed*1.5;
	}
	if(t_specy==2){
		t_mass=t_mass*1.5;
		t_speed=t_speed*0.5;
	}
	bb_bpb_ball_new.call(new bb_bpb_ball,t_posx,t_posy,bb_random_Rnd3(360.0),t_size,t_mass,t_speed,1+t_specy);
	return 0;
}
bb_bpb_ball.prototype.m_draw2=function(t_cx,t_cy){
	var t_a=this.f_angle+Math.cos((bb_bpb_BPB_gametick*8)*D2R)*2.0;
	var t_usedsize=this.f_size;
	if(this.f_status<50){
		t_usedsize=this.f_size*(1.0+(50-this.f_status)/5.0);
	}
	bb_graphics_SetAlpha(1.0-(bb_math_Abs(this.f_status-50))/50.0);
	if(this.f_kind==0){
		bb_bpb_drawrotatedscaled(bb_bpb_BPB_gametype[0],this.f_x-t_cx,this.f_y-t_cy,1.5*t_usedsize/20.0,t_a);
	}else{
		bb_bpb_drawrotatedscaled(bb_bpb_BPB_gametype[this.f_kind],this.f_x-t_cx,this.f_y-t_cy,1.5*t_usedsize/20.0,t_a);
	}
	bb_graphics_SetAlpha(1.0);
	if(this.f_status>50){
		if(this.f_kind==0){
			t_usedsize=(this.f_status-50)/5.0;
		}else{
			t_usedsize=(25.0-bb_math_Abs2((this.f_status)-75.0))/20.0;
		}
		bb_bpb_drawrotatedscaled(bb_bpb_BPB_explode,this.f_x-t_cx,this.f_y-t_cy,t_usedsize,t_a+(bb_bpb_BPB_gametick*4));
	}
	if((this.f_shielded)!=0){
		bb_graphics_SetColor(255.0,0.0,0.0);
		bb_graphics_SetAlpha(0.5);
		bb_graphics_DrawCircle(this.f_x-t_cx,this.f_y-t_cy,this.f_size*2.0);
		bb_graphics_SetAlpha(1.0);
		bb_graphics_SetColor(255.0,255.0,255.0);
	}
	return 0;
}
function bb_bpb_ball_renderall(t_cx,t_cy){
	var t_i=0;
	for(t_i=0;t_i<=bb_bpb_ball_count-1;t_i=t_i+1){
		if(bb_bpb_ball_all[t_i].f_status>=100){
			continue;
		}
		bb_bpb_ball_all[t_i].m_draw2(t_cx,t_cy);
	}
	return 0;
}
function bb_bpb_platform(){
	Object.call(this);
	this.f_x=.0;
	this.f_y=.0;
	this.f_size=.0;
}
var bb_bpb_platform_count;
var bb_bpb_platform_all;
function bb_bpb_platform_flush(){
	var t_i=0;
	for(t_i=0;t_i<=bb_bpb_platform_count-1;t_i=t_i+1){
		bb_bpb_platform_all[t_i]=null;
	}
	bb_bpb_platform_count=0;
	return 0;
}
function bb_bpb_platform_new(t_px,t_py,t_s){
	this.f_x=t_px;
	this.f_y=t_py;
	this.f_size=t_s;
	bb_bpb_platform_all[bb_bpb_platform_count]=this;
	bb_bpb_platform_count=bb_bpb_platform_count+1;
	return this;
}
function bb_bpb_platform_new2(){
	return this;
}
bb_bpb_platform.prototype.m_draw=function(t_cx,t_cy){
	bb_graphics_DrawCircle(this.f_x-(t_cx),this.f_y-(t_cy),this.f_size);
	return 0;
}
function bb_bpb_platform_renderall(t_cx,t_cy){
	var t_i=0;
	bb_graphics_SetColor(0.0,128.0,255.0);
	bb_graphics_SetAlpha(0.5);
	for(t_i=0;t_i<=bb_bpb_platform_count-1;t_i=t_i+1){
		bb_bpb_platform_all[t_i].m_draw(t_cx,t_cy);
	}
	bb_graphics_SetColor(255.0,255.0,255.0);
	bb_graphics_SetAlpha(1.0);
	return 0;
}
function bb_input_MouseX(){
	return bb_input_device.MouseX();
}
function bb_input_MouseY(){
	return bb_input_device.MouseY();
}
function bb_input_MouseDown(t_button){
	return bb_input_device.KeyDown(1+t_button);
}
function bb_input_MouseHit(t_button){
	return bb_input_device.KeyHit(1+t_button);
}
var bb_random_Seed;
function bb_random_Rnd(){
	bb_random_Seed=bb_random_Seed*1664525+1013904223|0;
	return (bb_random_Seed>>8&16777215)/16777216.0;
}
function bb_random_Rnd2(t_low,t_high){
	return bb_random_Rnd3(t_high-t_low)+t_low;
}
function bb_random_Rnd3(t_range){
	return bb_random_Rnd()*t_range;
}
function bb_input_KeyHit(t_key){
	return bb_input_device.KeyHit(t_key);
}
function bb_input_KeyDown(t_key){
	return bb_input_device.KeyDown(t_key);
}
function bb_graphics_Cls(t_r,t_g,t_b){
	bb_graphics_renderDevice.Cls(t_r,t_g,t_b);
	return 0;
}
function bb_graphics_ValidateMatrix(){
	if((bb_graphics_context.f_matDirty)!=0){
		bb_graphics_context.f_device.SetMatrix(bb_graphics_context.f_ix,bb_graphics_context.f_iy,bb_graphics_context.f_jx,bb_graphics_context.f_jy,bb_graphics_context.f_tx,bb_graphics_context.f_ty);
		bb_graphics_context.f_matDirty=0;
	}
	return 0;
}
function bb_graphics_DrawCircle(t_x,t_y,t_r){
	bb_graphics_ValidateMatrix();
	bb_graphics_renderDevice.DrawOval(t_x-t_r,t_y-t_r,t_r*2.0,t_r*2.0);
	return 0;
}
function bb_math_Abs(t_x){
	if(t_x>=0){
		return t_x;
	}
	return -t_x;
}
function bb_math_Abs2(t_x){
	if(t_x>=0.0){
		return t_x;
	}
	return -t_x;
}
function bb_graphics_PushMatrix(){
	var t_sp=bb_graphics_context.f_matrixSp;
	bb_graphics_context.f_matrixStack[t_sp+0]=bb_graphics_context.f_ix;
	bb_graphics_context.f_matrixStack[t_sp+1]=bb_graphics_context.f_iy;
	bb_graphics_context.f_matrixStack[t_sp+2]=bb_graphics_context.f_jx;
	bb_graphics_context.f_matrixStack[t_sp+3]=bb_graphics_context.f_jy;
	bb_graphics_context.f_matrixStack[t_sp+4]=bb_graphics_context.f_tx;
	bb_graphics_context.f_matrixStack[t_sp+5]=bb_graphics_context.f_ty;
	bb_graphics_context.f_matrixSp=t_sp+6;
	return 0;
}
function bb_graphics_Transform(t_ix,t_iy,t_jx,t_jy,t_tx,t_ty){
	var t_ix2=t_ix*bb_graphics_context.f_ix+t_iy*bb_graphics_context.f_jx;
	var t_iy2=t_ix*bb_graphics_context.f_iy+t_iy*bb_graphics_context.f_jy;
	var t_jx2=t_jx*bb_graphics_context.f_ix+t_jy*bb_graphics_context.f_jx;
	var t_jy2=t_jx*bb_graphics_context.f_iy+t_jy*bb_graphics_context.f_jy;
	var t_tx2=t_tx*bb_graphics_context.f_ix+t_ty*bb_graphics_context.f_jx+bb_graphics_context.f_tx;
	var t_ty2=t_tx*bb_graphics_context.f_iy+t_ty*bb_graphics_context.f_jy+bb_graphics_context.f_ty;
	bb_graphics_SetMatrix(t_ix2,t_iy2,t_jx2,t_jy2,t_tx2,t_ty2);
	return 0;
}
function bb_graphics_Transform2(t_m){
	bb_graphics_Transform(t_m[0],t_m[1],t_m[2],t_m[3],t_m[4],t_m[5]);
	return 0;
}
function bb_graphics_Translate(t_x,t_y){
	bb_graphics_Transform(1.0,0.0,0.0,1.0,t_x,t_y);
	return 0;
}
function bb_graphics_Rotate(t_angle){
	bb_graphics_Transform(Math.cos((t_angle)*D2R),-Math.sin((t_angle)*D2R),Math.sin((t_angle)*D2R),Math.cos((t_angle)*D2R),0.0,0.0);
	return 0;
}
function bb_graphics_Scale(t_x,t_y){
	bb_graphics_Transform(t_x,0.0,0.0,t_y,0.0,0.0);
	return 0;
}
function bb_graphics_PopMatrix(){
	var t_sp=bb_graphics_context.f_matrixSp-6;
	bb_graphics_SetMatrix(bb_graphics_context.f_matrixStack[t_sp+0],bb_graphics_context.f_matrixStack[t_sp+1],bb_graphics_context.f_matrixStack[t_sp+2],bb_graphics_context.f_matrixStack[t_sp+3],bb_graphics_context.f_matrixStack[t_sp+4],bb_graphics_context.f_matrixStack[t_sp+5]);
	bb_graphics_context.f_matrixSp=t_sp;
	return 0;
}
function bb_graphics_DrawImage(t_image,t_x,t_y,t_frame){
	var t_f=t_image.f_frames[t_frame];
	if((bb_graphics_context.f_tformed)!=0){
		bb_graphics_PushMatrix();
		bb_graphics_Translate(t_x-t_image.f_tx,t_y-t_image.f_ty);
		bb_graphics_ValidateMatrix();
		if((t_image.f_flags&65536)!=0){
			bb_graphics_context.f_device.DrawSurface(t_image.f_surface,0.0,0.0);
		}else{
			bb_graphics_context.f_device.DrawSurface2(t_image.f_surface,0.0,0.0,t_f.f_x,t_f.f_y,t_image.f_width,t_image.f_height);
		}
		bb_graphics_PopMatrix();
	}else{
		bb_graphics_ValidateMatrix();
		if((t_image.f_flags&65536)!=0){
			bb_graphics_context.f_device.DrawSurface(t_image.f_surface,t_x-t_image.f_tx,t_y-t_image.f_ty);
		}else{
			bb_graphics_context.f_device.DrawSurface2(t_image.f_surface,t_x-t_image.f_tx,t_y-t_image.f_ty,t_f.f_x,t_f.f_y,t_image.f_width,t_image.f_height);
		}
	}
	return 0;
}
function bb_graphics_DrawImage2(t_image,t_x,t_y,t_rotation,t_scaleX,t_scaleY,t_frame){
	var t_f=t_image.f_frames[t_frame];
	bb_graphics_PushMatrix();
	bb_graphics_Translate(t_x,t_y);
	bb_graphics_Rotate(t_rotation);
	bb_graphics_Scale(t_scaleX,t_scaleY);
	bb_graphics_Translate(-t_image.f_tx,-t_image.f_ty);
	bb_graphics_ValidateMatrix();
	if((t_image.f_flags&65536)!=0){
		bb_graphics_context.f_device.DrawSurface(t_image.f_surface,0.0,0.0);
	}else{
		bb_graphics_context.f_device.DrawSurface2(t_image.f_surface,0.0,0.0,t_f.f_x,t_f.f_y,t_image.f_width,t_image.f_height);
	}
	bb_graphics_PopMatrix();
	return 0;
}
function bb_bpb_drawrotatedscaled(t_img,t_px,t_py,t_scale,t_angle){
	if(t_scale==0.0){
		return 0;
	}
	var t_a=-t_angle-90.0;
	bb_graphics_PushMatrix();
	bb_graphics_Translate(t_px,t_py);
	bb_graphics_Rotate(t_a);
	bb_graphics_Scale(t_scale,t_scale);
	bb_graphics_Translate(-t_px,-t_py);
	t_img.m_SetHandle(32.0,32.0);
	bb_graphics_DrawImage(t_img,t_px,t_py,0);
	bb_graphics_PopMatrix();
	return 0;
}
function bb_graphics_DrawRect(t_x,t_y,t_w,t_h){
	bb_graphics_ValidateMatrix();
	bb_graphics_renderDevice.DrawRect(t_x,t_y,t_w,t_h);
	return 0;
}
function bb_bpb_timing(t_octet){
	if(t_octet==1){
		t_octet=0;
	}
	var t_totalcenti=t_octet*2;
	var t_mins=((t_totalcenti/6000)|0);
	var t_secs=((t_totalcenti/100)|0)-t_mins*60;
	var t_centi=t_totalcenti-t_mins*6000-t_secs*100;
	var t_strmin="0"+String(t_mins);
	var t_strsec="0"+String(t_secs);
	var t_strcen="0"+String(t_centi);
	var t_tps=t_strmin.slice(-2)+":"+t_strsec.slice(-2)+"'"+t_strcen.slice(-2);
	return t_tps;
}
function bb_graphics_DrawText(t_text,t_x,t_y,t_xalign,t_yalign){
	if(!((bb_graphics_context.f_font)!=null)){
		return 0;
	}
	var t_w=bb_graphics_context.f_font.m_Width();
	var t_h=bb_graphics_context.f_font.m_Height();
	t_x-=Math.floor((t_w*t_text.length)*t_xalign);
	t_y-=Math.floor((t_h)*t_yalign);
	for(var t_i=0;t_i<t_text.length;t_i=t_i+1){
		var t_ch=t_text.charCodeAt(t_i)-bb_graphics_context.f_firstChar;
		if(t_ch>=0 && t_ch<bb_graphics_context.f_font.m_Frames()){
			bb_graphics_DrawImage(bb_graphics_context.f_font,t_x+(t_i*t_w),t_y,t_ch);
		}
	}
	return 0;
}
function bb_graphics_DrawLine(t_x1,t_y1,t_x2,t_y2){
	bb_graphics_ValidateMatrix();
	bb_graphics_renderDevice.DrawLine(t_x1,t_y1,t_x2,t_y2);
	return 0;
}
function bb_bpb_drawbox(t_x,t_y,t_w,t_h){
	bb_graphics_DrawLine((t_x),(t_y),(t_x+t_w),(t_y));
	bb_graphics_DrawLine((t_x),(t_y),(t_x),(t_y+t_h));
	bb_graphics_DrawLine((t_x),(t_y+t_h),(t_x+t_w),(t_y+t_h));
	bb_graphics_DrawLine((t_x+t_w),(t_y),(t_x+t_w),(t_y+t_h));
	return 0;
}
function bbInit(){
	bb_graphics_context=null;
	bb_input_device=null;
	bb_audio_device=null;
	bb_app_device=null;
	bb_graphics_Image_DefaultFlags=0;
	bb_graphics_renderDevice=null;
	bb_bpb_BPB_Z=null;
	bb_bpb_BPB_twi=null;
	bb_bpb_BPB_unicorn=null;
	bb_bpb_BPB_pegasus=null;
	bb_bpb_BPB_earth=null;
	bb_bpb_BPB_explode=null;
	bb_bpb_BPB_mask=null;
	bb_bpb_BPB_mainscreen=null;
	bb_bpb_BPB_instructions=null;
	bb_bpb_BPB_commands=null;
	bb_bpb_button_list=null;
	bb_bpb_button_all=new_object_array(4);
	bb_bpb_BPB_gameover=null;
	bb_bpb_BPB_gametype=[];
	bb_bpb_BPB_gametick=0;
	bb_bpb_ball_main=null;
	bb_bpb_ball_limit1=null;
	bb_bpb_ball_limit2=null;
	bb_bpb_ball_kills=0;
	bb_bpb_ball_count=0;
	bb_bpb_ball_all=new_object_array(2048);
	bb_bpb_platform_count=0;
	bb_bpb_platform_all=new_object_array(32);
	bb_bpb_BPB_player=null;
	bb_bpb_ball_autoplay=0;
	bb_bpb_BPB_gamestatus=0;
	bb_bpb_button_width=300;
	bb_bpb_button_height=45;
	bb_random_Seed=1234;
	bb_bpb_BPB_camerax=.0;
	bb_bpb_BPB_cameray=.0;
}
//${TRANSCODE_END}
